DrawXNETButton  PROTO :HDC, :DWORD, :BYTE
DrawXPButton    PROTO :HDC, :DWORD, :BYTE
Draw8bitClr     PROTO :HDC, :DWORD, :BYTE

DrawXNETButton proc hBtnDC:HDC, lpRect:DWORD, State:BYTE

LOCAL color_1   :COLORREF
LOCAL color_2   :COLORREF
LOCAL color_3   :COLORREF
LOCAL brushFrame:HBRUSH
LOCAL brushFill :HBRUSH
LOCAL r,g,b     :DWORD
LOCAl clr_start, clr_end    :COLORREF
LOCAL OldPen    :HPEN
LOCAL OldBrush  :HBRUSH
LOCAL tmp_clr   :COLORREF

    call NumColorBits
    .if eax > 8

        .if State == BTN_STATE_PUSH
        
            call GetXpHighlightColor
            mov color_3, eax    
            
            invoke LightenColor, 164, color_3
            mov clr_end, eax
            invoke DarkenColor, 16, color_3
            mov clr_start, eax         
            
            invoke Gradient_Fill, hBtnDC, lpRect, clr_end, clr_start, RECT_V
            invoke MixedColor, clr_start, clr_end
            invoke DarkenColor, 70, eax
            mov tmp_clr, eax
            invoke CreateSolidBrush, eax
            push eax 
            invoke FrameRect, hBtnDC, lpRect, eax
            call DeleteObject 
            
            invoke InflateRect, lpRect, -1, -1
            invoke GetStockObject, WHITE_BRUSH
            invoke FrameRect, hBtnDC, lpRect, eax            
            
            invoke InflateRect, lpRect, -1, -1            
            invoke LightenColor, 118, tmp_clr
            invoke CreateSolidBrush, eax
            push eax
            invoke FrameRect, hBtnDC, lpRect, eax            
            call DeleteObject
            invoke InflateRect, lpRect, 2, 2 
        
        .elseif State == BTN_STATE_HOVER
        
            call GetXpHighlightColor
            mov color_3, eax    
            
            invoke LightenColor, 200, color_3
            mov clr_end, eax
            invoke DarkenColor, 24, color_3
            mov clr_start, eax
            
            invoke Gradient_Fill, hBtnDC, lpRect, clr_start, clr_end, RECT_V
            invoke MixedColor, clr_start, clr_end
            mov tmp_clr, eax
            invoke DarkenColor, 64, eax 
            invoke CreateSolidBrush, eax
            push eax 
            invoke FrameRect, hBtnDC, lpRect, eax
            call DeleteObject
            
            invoke InflateRect, lpRect, -1, -1
            invoke GetStockObject, WHITE_BRUSH
            invoke FrameRect, hBtnDC, lpRect, eax            
            
            invoke InflateRect, lpRect, -1, -1            
            invoke LightenColor, 128, tmp_clr
            invoke CreateSolidBrush, eax
            push eax
            invoke FrameRect, hBtnDC, lpRect, eax            
            call DeleteObject
            invoke InflateRect, lpRect, 2, 2               
        
        .elseif State == BTN_STATE_NORMAL
        
            mov color_2, $invoke ( GetSysColor, COLOR_BTNFACE )            
            
            invoke DarkenColor, 16, color_2
            m2m clr_start, color_2
            invoke LightenColor, 128, color_2
            mov clr_end, eax               
            invoke Gradient_Fill, hBtnDC, lpRect, clr_start, clr_end, RECT_V
            invoke MixedColor, clr_start, clr_end
            invoke DarkenColor, 64, eax
            mov tmp_clr, eax
            invoke CreateSolidBrush, eax
            mov brushFrame, eax 
            invoke FrameRect, hBtnDC, lpRect, brushFrame
            invoke DeleteObject, brushFrame
            
            invoke InflateRect, lpRect, -1, -1            
            
            invoke GetStockObject, WHITE_BRUSH
            invoke FrameRect, hBtnDC, lpRect, eax 
            
            invoke InflateRect, lpRect, -1, -1
            
            invoke LightenColor, 96, tmp_clr
            invoke CreateSolidBrush, eax
            push eax
            invoke FrameRect, hBtnDC, lpRect, eax            
            call DeleteObject
            invoke InflateRect, lpRect, 2, 2 
        
        .endif
        
    .else
    
        invoke Draw8bitClr, hBtnDC, lpRect, State
    
    .endif
    
	ret
DrawXNETButton endp

DrawXPButton proc hBtnDC:HDC, lpRect:DWORD, State:BYTE

LOCAL color_1   :COLORREF
LOCAL color_2   :COLORREF
LOCAL color_3   :COLORREF
LOCAL brushFrame:HBRUSH
LOCAL brushFill :HBRUSH
LOCAL r,g,b     :DWORD
LOCAl clr_start, clr_end    :COLORREF

    call NumColorBits
    .if eax > 8

        .if State == BTN_STATE_PUSH
        
            call GetXpHighlightColor
            mov color_3, eax
            mov color_2, $invoke ( GetSysColor, COLOR_BTNFACE )
            ;       
            invoke MixedColor, color_3, color_2
            invoke LightenColor, 72, eax
            mov color_2, eax
            invoke CreateSolidBrush, eax
            mov brushFill, eax                
            invoke MixedColor, color_3, color_2
            invoke DarkenColor, 64, eax
            invoke CreateSolidBrush, eax
            mov brushFrame, eax
            invoke FillRect, hBtnDC, lpRect, brushFill
            invoke FrameRect, hBtnDC, lpRect, brushFrame
            invoke DeleteObject, brushFill
            invoke DeleteObject, brushFrame
        
        .elseif State == BTN_STATE_HOVER
        
            call GetXpHighlightColor
            mov color_3, eax
            mov color_2, $invoke ( GetSysColor, COLOR_BTNFACE )
            ;       
            invoke MixedColor, color_3, color_2
            invoke LightenColor, 128, eax
            invoke CreateSolidBrush, eax
            mov brushFill, eax                
            invoke MixedColor, color_3, color_2  
            invoke DarkenColor, 64, eax
            invoke CreateSolidBrush, eax
            mov brushFrame, eax 
            jmp @f
        
        .elseif State == BTN_STATE_NORMAL
        
            mov color_1, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
            mov color_2, $invoke ( GetSysColor, COLOR_BTNFACE )
            ;  
            invoke GrayColor, color_2
            mov edx, 255
            sub edx, eax        
            .if eax > 215
                invoke MixedColor, color_2, color_1          
            .else   
                invoke LightenColor, edx, color_2  
            .endif                        
            invoke CreateSolidBrush, eax
            mov brushFill, eax 
            invoke MixedColor, color_2, color_1  
            invoke DarkenColor, 64, eax
            invoke CreateSolidBrush, eax
            mov brushFrame, eax
        @@:        
            invoke FillRect, hBtnDC, lpRect, brushFill
            invoke FrameRect, hBtnDC, lpRect, brushFrame
            invoke DeleteObject, brushFill
            invoke DeleteObject, brushFrame              
            
        .endif
        
    .else
    
        invoke Draw8bitClr, hBtnDC, lpRect, State
    
    .endif

	ret
DrawXPButton endp

Draw8bitClr proc hBtnDC:HDC, lpRect:DWORD, State:BYTE

    .if State == BTN_STATE_PUSH
   
        invoke GetSysColorBrush, COLOR_WINDOW
        invoke FillRect, hBtnDC, lpRect, eax
        invoke GetSysColorBrush, COLOR_BTNTEXT
        invoke FrameRect, hBtnDC, lpRect, eax
   
    .elseif State == BTN_STATE_HOVER
    
        invoke GetSysColorBrush, COLOR_3DLIGHT
        invoke FillRect, hBtnDC, lpRect, eax
        invoke GetSysColorBrush, COLOR_BTNSHADOW
        invoke FrameRect, hBtnDC, lpRect, eax    
    
    .elseif State == BTN_STATE_NORMAL
    
        invoke GetSysColorBrush, COLOR_BTNFACE
        invoke FillRect, hBtnDC, lpRect, eax
        invoke GetSysColorBrush, COLOR_BTNSHADOW
        invoke FrameRect, hBtnDC, lpRect, eax
    
    .endif   

	ret
Draw8bitClr endp