; #########################################################################
;                                                                         ;
;   WM_DrawItem_Menu ( XP)                              ;
;                                                                         ;
; #########################################################################

DrawItem_MenuXP proc ;lParam:LPARAM

    LOCAL mii         :MENUITEMINFOM
    LOCAL mi          :MENUINFO
    LOCAl TextItemLen :DWORD
    LOCAL szBuff[max_len_menu_item] :BYTE
    LOCAL hIcon       :HICON
    LOCAL temp        :DWORD
    LOCAL WidthBorder :DWORD  
    LOCAL tSelect     :BYTE         ;        .
    LOCAL RctText     :RECT
    LOCAL RctIcon     :RECT
    LOCAL RctBorder   :RECT
    LOCAL RctSep      :RECT
    LOCAL RctShade    :RECT
    LOCAL RctCorner   :RECT
    LOCAL RctCheck    :RECT
    LOCAL RctLeftBorder:RECT

    LOCAL hBrushSel   :HBRUSH
    LOCAL hBrushSelBor:HBRUSH
    LOCAL hBrushSep   :HBRUSH  ;        CheckItema
    LOCAL hBrushRight :HBRUSH  ;    ,    .
    LOCAL hBrushBorder:HBRUSH
    
    LOCAL colorText   :COLORREF
    LOCAL colorWindow :COLORREF
    LOCAL colorMenu   :COLORREF
    LOCAL colorMenuBar:COLORREF
    LOCAL colorBorder :COLORREF
    LOCAL colorBitmap :COLORREF
    LOCAL colorSel    :COLORREF
    LOCAL colorSep    :COLORREF
    
    LOCAL fDrawState  :BYTE
    
    LOCAL iconinfo    :ICONINFO

    ; ,   ..      

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    mov colorMenuBar, $invoke ( GetSysColor, COLOR_MENU )
    mov colorWindow, $invoke ( GetSysColor, COLOR_WINDOW )
    mov colorBitmap, $invoke ( MixedColor, colorMenuBar, colorWindow )
    mov colorSep, $invoke ( GetSysColor, COLOR_GRAYTEXT )   
    call GetXpHighlightColor
    mov colorSel, eax

    call NumColorBits
    .if eax > 8
        ;         
        invoke MidColor, colorSel, colorMenuBar
        invoke LightenColor, 64, eax
        invoke CreateSolidBrush, eax
        mov hBrushSel, eax
        invoke MixedColor, colorSel, colorMenuBar  
        invoke DarkenColor, 128, eax
        invoke CreateSolidBrush, eax
        mov hBrushSelBor, eax
        
        ;         ( - )
        invoke GrayColor, colorWindow
        mov edx, 255
        sub edx, eax        
        .if eax > 215
            invoke MixedColor, colorWindow, colorMenuBar        
        .else   
            invoke LightenColor, edx, colorWindow   
        .endif        
        invoke CreateSolidBrush, eax
        mov hBrushRight, eax
        
        ;              
        invoke GrayColor, colorMenuBar
        mov edx, 255
        sub edx, eax        
        .if eax > 215
            invoke MixedColor, colorMenuBar, colorBorder            
        .else   
            invoke LightenColor, edx, colorMenuBar  
        .endif        
        invoke CreateSolidBrush, eax
        mov hBrushBorder, eax
        
        ;  
        invoke DarkenColor, 8, colorSep
        invoke CreateSolidBrush, colorSep
        mov hBrushSep, eax
        
    .else
        invoke CreateSolidBrush, colorSel
        mov hBrushSel, eax
        invoke CreateSolidBrush, colorBorder
        mov hBrushSelBor, eax
        invoke CreateSolidBrush, colorWindow
        mov hBrushRight, eax
        invoke CreateSolidBrush, colorMenuBar
        mov hBrushBorder, eax
        invoke CreateSolidBrush, colorSep
        mov hBrushSep, eax
    .endif

; ======================================================================

assume ebx: ptr DRAWITEMSTRUCT

;         
    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA or MIIM_BITMAP or MIIM_FTYPE ;or MIIM_STRING
    invoke GetMenuItemInfo, [ebx].hwndItem, [ebx].itemID, FALSE, ADDR mii
    m2m hIcon, mii.dwItemData
    
    mov eax, mii.fType
    and eax, MFT_SEPARATOR or MFT_STRING or MFT_BITMAP

    .if eax == MFT_STRING                  ;   STRING
 
        ; IsIcon
        invoke GetIconInfo, hIcon, ADDR iconinfo
        cmp eax, 0 
        jne @f
        mov hIcon, FALSE
@@:    
        mov mi.cbSize, sizeof (MENUINFO)
        mov mi.fMask, MIM_MENUDATA
        invoke GetMenuInfo, [ebx].hwndItem, ADDR mi
        LOWORD mi.dwMenuData
        mov WidthBorder, eax    
    
        invoke GetMenuString, [ebx].hwndItem, [ebx].itemID, ADDR szBuff, max_len_menu_item, MF_BYCOMMAND ;  
        mov TextItemLen, eax

        .if [ebx].itemState & ODS_DEFAULT
            mov ecx, TRUE
        .else
            xor ecx, ecx
        .endif

            inc [ebx].rcItem.top
            dec [ebx].rcItem.bottom   
   
            ;     (٨?)
        
            .if [ebx].itemState & ODS_GRAYED
                invoke GetSysColor, COLOR_GRAYTEXT
                .if fSelection                      ;     .
                    mov tSelect, TRUE
                .else
                    mov tSelect, FALSE
                .endif
            .else
                invoke GetSysColor, COLOR_MENUTEXT
                mov tSelect, TRUE
            .endif
            invoke SetTextColor, [ebx].hdc, eax
        
            .if [ebx].itemState & ODS_SELECTED
                cmp tSelect, 0
                je @f      
                        
                invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushSel
                invoke FrameRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushSelBor
                mov fDrawState, SELECT
                                        
@@:
            .else
            
                dec [ebx].rcItem.top        ;   1 ,  MEASUREITEM  2
                inc [ebx].rcItem.bottom     ;      
                
                invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushBorder   
                
                ;        
        
                invoke CopyRect, ADDR RctBorder, ADDR [ebx].rcItem
                mov eax, WidthBorder
                add RctBorder.left, eax                 
                invoke FillRect, [ebx].hdc, ADDR RctBorder, hBrushRight                
                
                inc [ebx].rcItem.top        ;   1 ,  MEASUREITEM  2
                dec [ebx].rcItem.bottom     ;      
                          
                mov fDrawState, UNSELECT
            .endif
              
           .if [ebx].itemState & ODS_GRAYED
                mov fDrawState, GRAY
           .endif
            
           .if [ebx].itemState & ODS_CHECKED    ;           
               
                .if hIcon
                
                    .if fDrawState != SELECT
                
                        mov eax, [ebx].rcItem.left        ;   
                        mov RctCheck.left, eax
                        mov eax, [ebx].rcItem.top
                        mov RctCheck.top, eax
                        mov eax, [ebx].rcItem.left
                        add eax, WidthBorder
                        mov RctCheck.right, eax
                        mov eax, [ebx].rcItem.bottom
                        mov RctCheck.bottom, eax
                        invoke InflateRect, ADDR RctCheck, -1, -1
                
                        invoke DrawEdge, [ebx].hdc, ADDR RctCheck, BDR_SUNKENOUTER, BF_RECT               
                
                    .endif
                
                    .if fDrawState == SELECT
                        mov fDrawState, UNSELECT
                    .endif                
             
                    mov eax, [ebx].rcItem.left        ;   
                    mov RctIcon.left, eax
                    mov eax, [ebx].rcItem.top
                    mov RctIcon.top, eax
                    mov eax, [ebx].rcItem.left
                    add eax, WidthBorder
                    mov RctIcon.right, eax
                    mov eax, [ebx].rcItem.bottom
                    mov RctIcon.bottom, eax
                
                    invoke DrawIcnRect, [ebx].hdc, ADDR RctIcon, hIcon, fDrawState, FALSE    ; DRAW ICON
                   
                .else
               
                    ;              
                    ;              
                    mov eax, mii.fType
                    and eax, MFT_RADIOCHECK
                    .if eax == MFT_RADIOCHECK
                        mov al, TRUE
                    .else
                        mov al, FALSE
                    .endif
                    invoke DrawCheck_XP, [ebx].hdc, ADDR [ebx].rcItem, WidthBorder, fDrawState, al
        
                .endif
        
           .else
           
                .if hIcon
                
                    mov eax, [ebx].rcItem.left        ;   
                    mov RctIcon.left, eax
                    mov eax, [ebx].rcItem.top
                    mov RctIcon.top, eax
                    mov eax, [ebx].rcItem.left
                    add eax, WidthBorder
                    mov RctIcon.right, eax
                    mov eax, [ebx].rcItem.bottom
                    mov RctIcon.bottom, eax
                
                    invoke DrawIcnRect, [ebx].hdc, ADDR RctIcon, hIcon, fDrawState, FALSE    ; DRAW ICON
                    
                .elseif mii.hbmpItem                    
                    invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, fDrawState, WidthBorder                    
                .endif
                    
           .endif

           .if TextItemLen
        
                ; 
                
                ;   
                invoke CopyRect, ADDR RctText, ADDR [ebx].rcItem
                mov eax, WidthBorder
                add RctText.left, eax
                add RctText.left,4        ;         
                ;sub RctText.right, 5     ;        Tab
                    
                ;  
                HIWORD mi.dwMenuData               
                invoke DrawMenuString, [ebx].hdc, [ebx].hwndItem, ADDR szBuff, TextItemLen, ADDR RctText, eax
            
           .endif
           
           dec [ebx].rcItem.top
           inc [ebx].rcItem.bottom
    
    .elseif eax == MFT_SEPARATOR           ;   SEPARATOR

        .if hIcon
    
            invoke GetClipBox, [ebx].hdc, ADDR RctLeftBorder
            m2m RctLeftBorder.left, -3;[ebx].rcItem.left
            m2m RctLeftBorder.right, [ebx].rcItem.right

;            mov eax, offset RctLeftBorder
            lea eax, RctLeftBorder
            push eax
            push [ebx].hdc
            push [ebx].hwndItem
            call hIcon
           
        .else    
    
            mov mi.cbSize, sizeof (MENUINFO)
            mov mi.fMask, MIM_MENUDATA
            invoke GetMenuInfo, [ebx].hwndItem, ADDR mi
            LOWORD mi.dwMenuData
            mov WidthBorder, eax        
    
            invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushBorder        
            invoke CopyRect, ADDR RctBorder, ADDR [ebx].rcItem
            mov eax, WidthBorder
            add RctBorder.left, eax                     
            invoke FillRect, [ebx].hdc, ADDR RctBorder, hBrushRight
            
            ; Draw the seperator
             
            invoke CopyRect, ADDR RctSep, ADDR [ebx].rcItem
            mov eax, WidthBorder        
            add RctSep.left, eax
            add RctSep.left, 5          ; 5 -      
            mov eax, RctSep.bottom
            sub eax, RctSep.top
            shr eax, 1
            add RctSep.top, eax
            m2m RctSep.bottom, RctSep.top
            dec RctSep.top
            ;inc RctSep.bottom            
            invoke FillRect, [ebx].hdc, ADDR RctSep, hBrushSep
        
        .endif 
    
    .elseif eax == MFT_BITMAP              ;   BITMAP
    
    
    
    .endif

    invoke DeleteObject, hBrushSel
    invoke DeleteObject, hBrushSelBor
    invoke DeleteObject, hBrushSep      ;        CheckItema
    invoke DeleteObject, hBrushRight    ;    ,    .
    invoke DeleteObject, hBrushBorder

assume ebx: nothing        
   ret
DrawItem_MenuXP endp

; #########################################################################
;                                                                         ;
;        XP                      ;                           ;
;                                                                         ;
; #########################################################################

DrawCheck_XP proc uses ebx hDC:HDC, lpRect:DWORD, WidthBorder:DWORD, State:BYTE, CheckMark:BYTE

LOCAL RctCheck              :RECT
LOCAL hPen                  :HPEN
LOCAL hBrush                :HBRUSH    ;   CheckItema
LOCAL OldPen                :HPEN      ;     
LOCAL OldBrush              :HBRUSH
LOCAL hGlyphFont            :HFONT
LOCAL OldFont               :HFONT     ;    
LOCAL colorSel              :COLORREF
LOCAL colorBorder           :COLORREF
LOCAL GlyphArray[2]         :BYTE
LOCAL ncinfo                :NONCLIENTMETRICS

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    call GetXpHighlightColor
    mov colorSel, eax
    
   ;     CheckItema.   
   
    mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)           ;   
    invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                              sizeof(NONCLIENTMETRICS),\
                              addr ncinfo, 0                                      ;  ,    
    
 
    .if ncinfo.lfMenuFont.lfHeight > -15
        mov ncinfo.lfMenuFont.lfHeight, -15
    .endif

;   mov ncinfo.lfMenuFont.lfWidth, 14
    
    mov ncinfo.lfMenuFont.lfCharSet, DEFAULT_CHARSET
    
    invoke memfill, ADDR ncinfo.lfMenuFont.lfFaceName, LF_FACESIZE, 0
    invoke szCopy, ADDR szGlyphFont, ADDR ncinfo.lfMenuFont.lfFaceName                             
    invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont
       
    mov hGlyphFont, eax             ;   

    mov ebx, lpRect

    mov eax, [ebx].RECT.left        ;   
    mov RctCheck.left, eax
    mov eax, [ebx].RECT.top
    mov RctCheck.top, eax
    mov eax, [ebx].RECT.left
    add eax, WidthBorder
    mov RctCheck.right, eax
    mov eax, [ebx].RECT.bottom
    mov RctCheck.bottom, eax
    invoke InflateRect, ADDR RctCheck, -2, -2

;--------------      ------------------
    
    xor eax, eax                    ;  
    mov al, State 
    and al, GRAY or SELECT or UNSELECT

    .if al == GRAY    
        call NumColorBits
        .if eax > 8
            ;        CheckItema    
            invoke LightenColor, 128, $invoke ( GetSysColor, COLOR_GRAYTEXT )
            invoke CreateSolidBrush, eax
            mov hBrush, eax    
            invoke DarkenColor, 8, $invoke ( GetSysColor, COLOR_GRAYTEXT )
            invoke CreatePen,PS_SOLID,1,eax
            mov hPen, eax
        .else
            invoke CreateSolidBrush, $invoke ( GetSysColor, COLOR_MENU )
            mov hBrush, eax
            invoke CreatePen,PS_SOLID,1, $invoke ( GetSysColor, COLOR_GRAYTEXT )
            mov hPen, eax             
        .endif
        
    .elseif al == SELECT
    
        call NumColorBits
        .if eax > 8
            ;       CheckItema   
            invoke MixedColor, colorSel, colorBorder
            invoke CreateSolidBrush, eax
            mov hBrush, eax
            invoke MixedColor, colorSel, colorBorder
            invoke DarkenColor, 128, eax
            invoke CreatePen,PS_SOLID,1,eax
            mov hPen, eax
        .else
            invoke CreateSolidBrush, colorSel
            mov hBrush, eax
            invoke CreatePen,PS_SOLID,1, colorBorder
            mov hPen, eax  
        .endif
     
    .elseif al == UNSELECT

        call NumColorBits
        .if eax > 8
            ;     CheckItema   .
            invoke MixedColor, colorSel, colorBorder
            invoke LightenColor, 128, eax
            invoke CreateSolidBrush, eax
            mov hBrush, eax        
            invoke MixedColor, colorSel, colorBorder
            invoke DarkenColor, 128, eax
            invoke CreatePen,PS_SOLID,1,eax
            mov hPen, eax
        .else
            invoke CreateSolidBrush, $invoke ( GetSysColor, COLOR_MENU )
            mov hBrush, eax
            invoke CreatePen,PS_SOLID,1, colorSel
            mov hPen, eax  
        .endif
    
    .endif

;--------------  CheckItema----------------------------------------

    mov OldPen, $invoke ( SelectObject, hDC, hPen )
    mov OldBrush, $invoke ( SelectObject, hDC, hBrush )

    invoke Rectangle,hDC,RctCheck.left,RctCheck.top,
                     RctCheck.right,RctCheck.bottom

    invoke SelectObject, hDC, OldPen
    invoke SelectObject, hDC, OldBrush
    invoke DeleteObject, hBrush
    invoke DeleteObject, hPen
    
;-------------- -------------------------------------------------
    
    invoke SetBkMode,hDC,TRANSPARENT
    invoke SelectObject, hDC, hGlyphFont
    mov OldFont, eax
    
    .if CheckMark               
        mov GlyphArray, 69h         ; Bullet
    .else
        add RctCheck.top, 1  
        mov GlyphArray, 62h         ; Checkmark
    .endif 
                               
    invoke DrawText, hDC,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER or DT_SINGLELINE   
    
    invoke SelectObject, hDC, OldFont   ;       
    invoke DeleteObject, hGlyphFont
    
    ret
DrawCheck_XP endp