; #########################################################################
;                                                                         ;
;       OWNERDRAW                   ;
;                                                                         ;
; #########################################################################

SubMenuToOwnerdraw proc h_Menu :HMENU

LOCAL nHightItemCount :DWORD
LOCAL nCount          :DWORD
LOCAL hSubMenu        :HMENU
LOCAL mii             :MENUITEMINFOM

    mov mii.cbSize, sizeof (MENUITEMINFOM)
        
    mov nHightItemCount, $invoke (GetMenuItemCount, h_Menu)
    
    mov nCount, 0

@@: mov mii.fMask, MIIM_SUBMENU or MIIM_FTYPE or MIIM_ID
    invoke GetMenuItemInfo, h_Menu, nCount, TRUE, ADDR mii    
    
    mov mii.fMask, 0

    mov eax, mii.fType                      ;       OWNERDRAW,    
    and eax, MFT_OWNERDRAW
    cmp eax, MFT_OWNERDRAW
    je  y_o                                 ;   
    or mii.fType, MFT_OWNERDRAW
    mov mii.fMask, MIIM_FTYPE
y_o:     
    .if !mii.wID                        ;     ID = 0,   ID
        or mii.fMask, MIIM_ID
        call ansi_rand
        mov mii.wID, eax
    .endif

    .if mii.fMask
        invoke SetMenuItemInfo, h_Menu, nCount, TRUE, ADDR mii
    .endif
  
    .if mii.hSubMenu
        invoke SubMenuToOwnerdraw, mii.hSubMenu
    .endif

    inc nCount
    
    mov eax, nCount
    cmp eax, nHightItemCount    
    jb  @b    
    
    ret
SubMenuToOwnerdraw endp

; #########################################################################
;                                                                         ;
;       OWNERDRAW                            ;
;                                                                         ;
; #########################################################################

OwnerDrawToNormal proc h_Menu :HMENU

LOCAL nHightItemCount :DWORD
LOCAL nCount          :DWORD
LOCAL hSubMenu        :HMENU
LOCAL mii             :MENUITEMINFOM

    mov mii.cbSize, sizeof (MENUITEMINFOM) 
    
    mov nHightItemCount, $invoke (GetMenuItemCount, h_Menu)
    
    mov nCount, 0

@@: 
    mov mii.fMask, MIIM_SUBMENU or MIIM_FTYPE or MIIM_DATA
    invoke GetMenuItemInfo, h_Menu, nCount, TRUE, ADDR mii    

    mov eax, mii.fType                      ;       OWNERDRAW,    
    and eax, MFT_OWNERDRAW
    cmp eax, MFT_OWNERDRAW
    pushfd
    
    ;   ,    
    .if (mii.fType & MFT_SEPARATOR) && mii.dwItemData
        popfd
        je n_y_o                            ;   
        or mii.fType, MFT_OWNERDRAW
    .else
        popfd
        jne n_y_o                           ;   
        xor mii.fType, MFT_OWNERDRAW
    .endif
    
    mov mii.fMask, MIIM_FTYPE
    invoke SetMenuItemInfo, h_Menu, nCount, TRUE, ADDR mii 
 
n_y_o: 
  
    .if mii.hSubMenu
        invoke OwnerDrawToNormal, mii.hSubMenu
    .endif

    inc nCount  
    
    mov eax, nCount
    cmp eax, nHightItemCount    
    jb  @b    
    
    ret
OwnerDrawToNormal endp

; #########################################################################
;                                                                         ;
;    Windows                                            ;
;                                                                         ;
; #########################################################################

IsShellType proc

LOCAL osvi  :OSVERSIONINFO
LOCAL winVer:DWORD

    xor eax, eax
    .if !ShellType
        mov osvi.dwOSVersionInfoSize, sizeof (OSVERSIONINFO)
        invoke GetVersionEx, ADDR osvi 
        .if osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1 ; Windows XP      
            mov al, WIN_XP
        .elseif osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0 ; Windows 2000
            mov al, WIN_2000
        .elseif osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 90 ; Windows Me     
            mov al, WIN_ME
        .elseif osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 10 ; Windows 98     
            mov al, WIN_98
        .elseif osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2 ; Windows Server 2003 family     
            mov al, WIN_2003
        .elseif osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0 ; Windows 95     
            mov al, WIN_95
        .elseif osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0 ; Windows NT 4.0     
            mov al, WIN_NT4
        .elseif osvi.dwMajorVersion == 3 && osvi.dwMinorVersion == 51 ; Windows NT 3.51     
            mov al, WIN_NT3
        .endif
        mov ShellType, al
    .else
        mov al, ShellType
    .endif
      
    ret
IsShellType endp

; #########################################################################
;                                                                         ;
;   XP,    , ID  ,      ; 
;                                                           ;
; Special purpose for windows XP with themes!!!                           ;
;                                                                         ;
; #########################################################################

IsID_ThemeXP_inc proc hWin :HWND, h_Menu :HMENU

    LOCAL nHightItemCount :DWORD
    LOCAL nCount          :DWORD
    LOCAL hSubMenu        :HMENU
    LOCAL mii             :MENUITEMINFOM

    call IsShellType
    .if eax != WIN_XP
        jmp e_t
    .endif

    mov mii.cbSize, sizeof (MENUITEMINFOM)
        
    mov nHightItemCount, $invoke (GetMenuItemCount, h_Menu)
    
    mov nCount, 0
    mov mii.fMask, MIIM_ID

@@: invoke GetMenuItemInfo, h_Menu, nCount, TRUE, ADDR mii    
    
    ;     Windows XP (Special purpose for windows XP with themes!!!)
    .if mii.wID == SC_RESTORE
        mov mii.wID, SC_RESTORE+1
    .elseif mii.wID == SC_CLOSE
        mov mii.wID, SC_CLOSE+1
    .elseif mii.wID == SC_MINIMIZE
        mov mii.wID, SC_MINIMIZE+1
    .else
        jmp no_sc
    .endif    

    invoke SetMenuItemInfo, h_Menu, nCount, TRUE, ADDR mii
no_sc:
    inc nCount
    
    mov eax, nCount
    cmp eax, nHightItemCount    
    jb  @b    
    
e_t:ret
IsID_ThemeXP_inc endp

; #########################################################################
;                                                                         ;
;   XP,    , ID  ,      ; 
;                                                           ;
; Special purpose for windows XP with themes!!!                           ; 
;                                                                         ;
; #########################################################################

IsID_ThemeXP_dec proc hWin :HWND, h_Menu :HMENU

    LOCAL nHightItemCount :DWORD
    LOCAL nCount          :DWORD
    LOCAL hSubMenu        :HMENU
    LOCAL mii             :MENUITEMINFOM

    call IsShellType
    .if eax != WIN_XP
        jmp e_t
    .endif

    mov mii.cbSize, sizeof (MENUITEMINFOM)
        
    mov nHightItemCount, $invoke (GetMenuItemCount, h_Menu)
    
    mov nCount, 0
    mov mii.fMask, MIIM_ID
    
@@: invoke GetMenuItemInfo, h_Menu, nCount, TRUE, ADDR mii    
    
    ;     Windows XP (Special purpose for windows XP with themes!!!)
    .if mii.wID == SC_RESTORE+1
        mov mii.wID, SC_RESTORE
    .elseif mii.wID == SC_CLOSE+1
        mov mii.wID, SC_CLOSE
    .elseif mii.wID == SC_MINIMIZE+1
        mov mii.wID, SC_MINIMIZE
    .else
        jmp no_sc
    .endif    

    invoke SetMenuItemInfo, h_Menu, nCount, TRUE, ADDR mii
no_sc:
    inc nCount
    
    mov eax, nCount
    cmp eax, nHightItemCount    
    jb  @b    
    
e_t:ret
IsID_ThemeXP_dec endp