EnumWindowProc      PROTO :HWND, :LPARAM
HookProcTransparent PROTO :DWORD, :DWORD, :DWORD

InstallHookTransparent proc
    call IsShellType
    .if eax >= WIN_2000
        .if !hHookTransparent
            call GetCurrentThreadId
            invoke SetWindowsHookEx, WH_CALLWNDPROC, ADDR HookProcTransparent, NULL, eax
            mov hHookTransparent, eax
        .endif
    .endif  
    
    ret
InstallHookTransparent endp

UnInstallHookTransparent proc
    .if hHookTransparent
        invoke UnhookWindowsHookEx, hHookTransparent 
        mov hHookTransparent, 0
    .endif
    ret
UnInstallHookTransparent endp

; ########################################################################

HookProcTransparent proc uses ebx nCode:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL class_name[8]:BYTE

    mov ebx, lParam
    assume ebx: ptr CWPSTRUCT   

    .if nCode == HC_ACTION
        
        .if [ebx].message == WM_NCCREATE || [ebx].message == WM_WINDOWPOSCHANGED || [ebx].message == WM_SHOWWINDOW
    
            invoke GetClassName, [ebx].hwnd, ADDR class_name, 7
    
            ; Check for the menu-class
            
            .if eax == 6
                invoke lstrcmp, ADDR class_name, ADDR ClassWndMenu
                
                .if !eax        
                    .if fTransparent
                            invoke SetWindowTransparent, [ebx].hwnd, dword ptr fTransparent
                    .endif
                .endif
            
            .endif
        
        .endif

    .endif
    
assume ebx: nothing
    invoke CallNextHookEx, hHookTransparent, nCode, wParam, lParam 
    xor eax, eax
    ret
HookProcTransparent endp

;--------------------------------------------------------------------------------

SetWindowTransparent proc hWin:HWND, dwAlpha:DWORD
  
LOCAL osvi  :OSVERSIONINFO  
LOCAl addr_proc:DWORD
LOCAL hMem  :DWORD

    invoke IsWindow, hWin
    .if !eax
        return FALSE
    .endif

    call IsShellType
    .if eax >= WIN_2000
    
        invoke LoadLibrary, ADDR szUser32
        invoke GetProcAddress, eax, ADDR szLayered
        mov addr_proc, eax
        .if eax
            invoke GlobalAlloc, GPTR, 8        ; 
            
            mov         edx, dwAlpha
            mov         [eax], edx            
            mov         edx, addr_proc 
            mov         [eax+4], edx
            mov         hMem, eax
            invoke EnumWindowProc, hWin, hMem   
            invoke EnumChildWindows, hWin, ADDR EnumWindowProc, hMem
            call GlobalFree
        .endif
    .endif

	ret
SetWindowTransparent endp

EnumWindowProc proc hWin:HWND, lParam:LPARAM

    invoke GetWindowLong, hWin, GWL_EXSTYLE
    .if lParam        
            .if !(eax & WS_EX_LAYERED)            
                or eax, WS_EX_LAYERED
                invoke SetWindowLong, hWin, GWL_EXSTYLE, eax
            .endif   
            mov edx, lParam
            push LWA_ALPHA        
            push [edx]
            push NULL
            push hWin
            mov eax, [edx+4]
            call eax
            ;invoke SetLayeredWindowAttributes, hWin, 0, lParam, LWA_ALPHA
    .else
        .if eax & WS_EX_LAYERED
            xor eax, WS_EX_LAYERED
            invoke SetWindowLong, hWin, GWL_EXSTYLE, eax
        .endif         
    .endif

    mov eax, TRUE
	ret
EnumWindowProc endp