; #########################################################################
;                                                                         ;
;   WM_DrawItem_Menu ( XP)                              ;
;                                                                         ;
; #########################################################################

DrawItem_MenuXNET proc uses ecx ;edx lParam:LPARAM

    LOCAL mii         :MENUITEMINFOM
    LOCAL mi          :MENUINFO
    LOCAl TextItemLen :DWORD
    LOCAL szBuff[max_len_menu_item] :BYTE
    LOCAL hIcon       :HICON
    LOCAL WidthBorder :DWORD 
    LOCAL bIcon       :BOOL
    LOCAL hMemDC      :HDC
    LOCAL hMemDDB     :HBITMAP
    LOCAL hOldBmp     :HBITMAP
    LOCAL iWidth      :DWORD
    LOCAL iHeight     :DWORD
    LOCAL temp        :DWORD
    LOCAL tSelect     :BYTE         ;        .
    LOCAL RctItem     :RECT
    LOCAL RctText     :RECT
    LOCAL RctIcon     :RECT
    LOCAL RctBorder   :RECT
    LOCAL RctSep      :RECT
    LOCAL RctShade    :RECT
    LOCAL RctCorner   :RECT
    LOCAL RctLeftBorder:RECT

    LOCAl hBrush      :HBRUSH
    LOCAL hPen        :HPEN
    LOCAl OldBrush    :HBRUSH
    LOCAL OldPen      :HPEN
    LOCAL RctCheck    :RECT

    LOCAL hBrushSel   :HBRUSH
    LOCAL hBrushSelBor:HBRUSH
    LOCAL hBrushSep   :HBRUSH  ;        CheckItema
    LOCAL hBrushRight :HBRUSH  ;    ,    .
    LOCAL hBrushBorder:HBRUSH
    
    LOCAL colorText   :COLORREF
    LOCAL colorWindow :COLORREF
    LOCAL colorMenu   :COLORREF
    LOCAL colorMenuBar:COLORREF
    LOCAL colorBorder :COLORREF
    LOCAL colorBitmap :COLORREF
    LOCAL colorSel    :COLORREF
    LOCAL colorSep    :COLORREF
    
    LOCAL clr_start   :COLORREF  
    LOCAL clr_end     :COLORREF
    
    LOCAL fDrawState  :BYTE
    
    LOCAL r           :DWORD
    LOCAL g           :DWORD
    LOCAL b           :DWORD
    
    LOCAL iconinfo    :ICONINFO

    ; ,   ..      

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    mov colorMenuBar, $invoke ( GetSysColor, COLOR_MENU )
    mov colorWindow, $invoke ( GetSysColor, COLOR_WINDOW )
    mov colorBitmap, $invoke ( MixedColor, colorMenuBar, colorWindow )
    mov colorSep, $invoke ( GetSysColor, COLOR_GRAYTEXT )   
    call GetXpHighlightColor
    mov colorSel, eax

    call NumColorBits
    .if eax > 8
    
        invoke MixedColor, colorSel, colorBorder
        invoke DarkenColor, 128, eax
        invoke CreateSolidBrush, eax
        mov hBrushSelBor, eax       

    .else
        invoke CreateSolidBrush, colorSel
        mov hBrushSel, eax
        invoke CreateSolidBrush, colorBorder
        mov hBrushSelBor, eax
        invoke CreateSolidBrush, colorWindow
        mov hBrushRight, eax
        invoke CreateSolidBrush, colorMenuBar
        mov hBrushBorder, eax
        invoke CreateSolidBrush, colorSep
        mov hBrushSep, eax
    .endif 

; ======================================================================

assume ebx: ptr DRAWITEMSTRUCT

;         
    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA or MIIM_BITMAP or MIIM_FTYPE ;or MIIM_STRING
    invoke GetMenuItemInfo, [ebx].hwndItem, [ebx].itemID, FALSE, ADDR mii    
    
    m2m hIcon, mii.dwItemData
    
    mov eax, mii.fType
    and eax, MFT_SEPARATOR or MFT_STRING or MFT_BITMAP    

    .if eax == MFT_STRING                  ;   STRING        

        ; IsIcon
        invoke GetIconInfo, hIcon, ADDR iconinfo
        cmp eax, 0 
        jne @f
        mov hIcon, NULL
@@:        

        mov mi.cbSize, sizeof (MENUINFO)
        mov mi.fMask, MIM_MENUDATA
        invoke GetMenuInfo, [ebx].hwndItem, ADDR mi
        LOWORD mi.dwMenuData
        mov WidthBorder, eax        

        invoke CreateCompatibleDC, [ebx].hdc
        mov hMemDC, eax
        
        invoke GetStockObject, DEFAULT_GUI_FONT
        invoke SelectObject, [ebx].hdc, eax
        push eax
        invoke SelectObject, hMemDC, eax
        ;  ,    
        push [ebx].hdc
        call SelectObject
        invoke SetBkMode, hMemDC, TRANSPARENT
        
        mov RctItem.left, 0
        mov RctItem.top, 0
        mov eax, [ebx].rcItem.right
        sub eax, [ebx].rcItem.left
        mov iWidth, eax
        mov RctItem.right, eax
        mov eax, [ebx].rcItem.bottom
        sub eax, [ebx].rcItem.top
        mov iHeight, eax
        mov RctItem.bottom, eax
        invoke CreateCompatibleBitmap, [ebx].hdc, iWidth, iHeight
        mov hMemDDB, eax
        invoke SelectObject, hMemDC, hMemDDB
        mov hOldBmp, eax 
   
        invoke GetMenuString, [ebx].hwndItem, [ebx].itemID, ADDR szBuff, max_len_menu_item, MF_BYCOMMAND ;  
        mov TextItemLen, eax
        
        .if [ebx].itemState & ODS_DEFAULT
            mov ecx, TRUE
        .else
            xor ecx, ecx
        .endif
;        invoke SetSizeBorder, hMemDC, ADDR szBuff, eax, hIcon, ecx
   
            ;     (٨?)
        
            .if [ebx].itemState & ODS_GRAYED
                invoke GetSysColor, COLOR_GRAYTEXT
                .if fSelection                      ;     .
                    mov tSelect, TRUE
                .else
                    mov tSelect, FALSE
                .endif
            .else
                invoke GetSysColor, COLOR_MENUTEXT
                mov tSelect, TRUE
            .endif
            invoke SetTextColor, hMemDC, eax
        
            .if [ebx].itemState & ODS_SELECTED
                cmp tSelect, 0
                je @f
                                
                call NumColorBits
                .if eax > 8
                
                    ;  , 
                    invoke DarkenColor, 16, colorMenuBar
                    m2m clr_start, eax
                    invoke LightenColor, 128, colorMenuBar
                    mov clr_end, eax
                    
                    invoke Gradient_Fill, hMemDC, ADDR RctItem, clr_start, clr_end, RECT_H                
                
                    invoke InflateRect, ADDR RctItem, -1, -1
                    dec RctItem.bottom
                    inc RctItem.top
                    invoke MidColor, colorSel, colorMenuBar
                    invoke DarkenColor, 16, eax
                    mov clr_start, eax
                    invoke MidColor, colorSel, colorMenuBar
                    invoke LightenColor, 128, eax
                    mov clr_end, eax               
                
                    invoke Gradient_Fill, hMemDC, ADDR RctItem, clr_start, clr_end,  RECT_V
                    invoke InflateRect, ADDR RctItem, 1, 1
                    invoke MixedColor, clr_start, clr_end
                    invoke DarkenColor, 64, eax
                    invoke CreateSolidBrush, eax
                    push eax 
                    invoke FrameRect, hMemDC, ADDR RctItem, eax
                    call DeleteObject
                    inc RctItem.bottom
                    dec RctItem.top
                .else 
                
                    invoke FillRect, hMemDC, ADDR RctItem, hBrushBorder
                    invoke InflateRect, ADDR RctItem, -1, -1 
                    dec RctItem.bottom
                    inc RctItem.top
                    invoke FillRect, hMemDC, ADDR RctItem, hBrushSel
                    invoke InflateRect, ADDR RctItem, 1, 1
                    invoke FrameRect, hMemDC, ADDR RctItem, hBrushSelBor
                    inc RctItem.bottom
                    dec RctItem.top
                .endif
                
                mov fDrawState, SELECT                                       

            .else
@@:             
                call NumColorBits
                .if eax > 8
                    invoke DarkenColor, 16, colorMenuBar
                    m2m clr_start, eax
                    invoke LightenColor, 128, colorMenuBar
                    mov clr_end, eax
                   
                    invoke Gradient_Fill, hMemDC, ADDR RctItem, clr_start, clr_end, RECT_H
                    
                .else
                    invoke FillRect, hMemDC, ADDR RctItem, hBrushBorder
                .endif

                mov fDrawState, UNSELECT
            .endif
              
           .if [ebx].itemState & ODS_GRAYED
                mov fDrawState, GRAY
           .endif
            
           .if [ebx].itemState & ODS_CHECKED    ;           
               
                inc RctItem.top
                dec RctItem.bottom
               
                .if hIcon
                
                    .if fDrawState == SELECT
                    
                        .if hIcon
                            invoke Icon_CopyAsBlend, [ebx].hdc, hIcon, 64
                            mov hIcon, eax
                            mov bIcon, TRUE
                        .else
                            mov bIcon, FALSE
                        .endif
                    
                        mov fDrawState, UNSELECT
                    .else
                        mov bIcon, FALSE
                    .endif
 
                    invoke DrawRctCheckXNET, hMemDC, ADDR RctItem, WidthBorder, fDrawState
                    
                    mov eax, RctItem.left        ;   
                    mov RctIcon.left, eax
                    mov eax, RctItem.top
                    mov RctIcon.top, eax
                    mov eax, RctItem.left
                    add eax, WidthBorder
                    mov RctIcon.right, eax
                    mov eax, RctItem.bottom
                    mov RctIcon.bottom, eax
                    
                    invoke DrawIcnRect, hMemDC, ADDR RctIcon, hIcon, fDrawState, FALSE
                    
                    .if bIcon
                        invoke DestroyIcon, hIcon
                    .endif
                                       
                .else
               
                    ;              
                    ;              
                    mov eax, mii.fType
                    and eax, MFT_RADIOCHECK
                    .if eax == MFT_RADIOCHECK
                        mov al, TRUE
                    .else
                        mov al, FALSE
                    .endif
                    invoke DrawCheckXNET, hMemDC, ADDR RctItem, WidthBorder, fDrawState, al
        
                .endif
                
                dec RctItem.top
                inc RctItem.bottom
        
           .else
           
                 .if fDrawState == SELECT
                    
                    .if hIcon
                        invoke Icon_CopyAsBlend, [ebx].hdc, hIcon, 64
                        mov hIcon, eax
                        mov bIcon, TRUE
                    .else
                        mov bIcon, FALSE
                    .endif
                    
                    mov fDrawState, UNSELECT
                 .else
                    mov bIcon, FALSE
                 .endif
          
                .if hIcon
                
                    mov eax, RctItem.left        ;   
                    mov RctIcon.left, eax
                    mov eax, RctItem.top
                    mov RctIcon.top, eax
                    mov eax, RctItem.left
                    add eax, WidthBorder
                    mov RctIcon.right, eax
                    mov eax, RctItem.bottom
                    mov RctIcon.bottom, eax                
                                   
                    invoke DrawIcnRect, hMemDC, ADDR RctIcon, hIcon, fDrawState, FALSE    ; DRAW ICON
                    
                    .if bIcon
                        invoke DestroyIcon, hIcon
                    .endif
                    
                .elseif mii.hbmpItem                    
                    invoke DrawBmp, hMemDC, ADDR RctItem, mii.hbmpItem, fDrawState, WidthBorder                     
                .endif
                    
           .endif
        
            ;
             
           .if TextItemLen
                   
                ;   
                invoke CopyRect, ADDR RctText, ADDR RctItem
                mov eax, WidthBorder
                add RctText.left, eax
                add RctText.left,4        ;         
                ;sub RctText.right, 5     ;        Tab
                
                ;  
                HIWORD mi.dwMenuData               
                invoke DrawMenuString, hMemDC, [ebx].hwndItem, ADDR szBuff, TextItemLen, ADDR RctText, eax
           .endif
           
           invoke BitBlt, [ebx].hdc, [ebx].rcItem.left, [ebx].rcItem.top, iWidth, iHeight, hMemDC, 0, 0,SRCCOPY
           invoke SelectObject, hMemDC, hOldBmp
           invoke DeleteObject, hMemDDB
           invoke DeleteDC, hMemDC    
    
    .elseif eax == MFT_SEPARATOR           ;   SEPARATOR
 
        .if hIcon
    
            invoke GetClipBox, [ebx].hdc, ADDR RctLeftBorder
            m2m RctLeftBorder.left, [ebx].rcItem.left
            m2m RctLeftBorder.right, [ebx].rcItem.right

;            mov eax, offset RctLeftBorder
            lea eax, RctLeftBorder
            push eax
            push [ebx].hdc
            push [ebx].hwndItem
            call hIcon
           
        .else 
    
         call NumColorBits
         .if eax > 8
            
            invoke DarkenColor, 16, colorMenuBar
            m2m clr_start, eax
            invoke LightenColor, 128, colorMenuBar
            mov clr_end, eax
            invoke Gradient_Fill, [ebx].hdc, ADDR [ebx].rcItem, clr_start, clr_end, RECT_H
        
         .else
            invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushBorder
         .endif        
;        invoke CopyRect, ADDR RctBorder, ADDR [ebx].rcItem
;        mov eax, WidthBorder
;        add RctBorder.left, eax                     
;        invoke FillRect, [ebx].hdc, ADDR RctBorder, hBrushRight
        
        ; Draw the seperator
         
            mov mi.cbSize, sizeof (MENUINFO)
            mov mi.fMask, MIM_MENUDATA
            invoke GetMenuInfo, [ebx].hwndItem, ADDR mi
            LOWORD mi.dwMenuData
            mov WidthBorder, eax             
         
            invoke CopyRect, ADDR RctSep, ADDR [ebx].rcItem
            mov eax, WidthBorder        
            add RctSep.left, eax
            add RctSep.left, 5          ; 5 -      
            mov eax, RctSep.bottom
            sub eax, RctSep.top
            shr eax, 1
            add RctSep.top, eax
            m2m RctSep.bottom, RctSep.top
            dec RctSep.top
            ;inc RctSep.bottom
                        
            call NumColorBits
            .if eax > 8
                invoke Gradient_Fill, [ebx].hdc, ADDR RctSep, colorSep, colorMenuBar, RECT_H
            .else
                invoke FillRect, [ebx].hdc, ADDR RctSep, hBrushSep
            .endif
            
        .endif
    
    .elseif eax == MFT_BITMAP              ;   BITMAP
    
    
    
    .endif

    invoke DeleteObject, hBrushSelBor
    call NumColorBits
    .if eax <= 8
        invoke DeleteObject, hBrushSel    
        invoke DeleteObject, hBrushSep      ;        CheckItema
        invoke DeleteObject, hBrushRight    ;    ,    .
        invoke DeleteObject, hBrushBorder
    .endif

assume ebx: nothing        
   ret
DrawItem_MenuXNET endp

; #########################################################################
;                                                                         ;
;        XP                      ;                           ;
;                                                                         ;
; #########################################################################

DrawCheckXNET proc uses ebx hDC:HDC, lpRect:DWORD, WidthBorder:DWORD, State:BYTE, CheckMark:BYTE

LOCAL RctCheck              :RECT
LOCAL hPen                  :HPEN
LOCAL hBrush                :HBRUSH    ;   CheckItema
LOCAL OldPen                :HPEN      ;     
LOCAL OldBrush              :HBRUSH
LOCAL hGlyphFont            :HFONT
LOCAL OldFont               :HFONT     ;    
LOCAL colorSel              :COLORREF
LOCAL colorBorder           :COLORREF
LOCAL GlyphArray[2]         :BYTE
LOCAL ncinfo                :NONCLIENTMETRICS

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    call GetXpHighlightColor
    mov colorSel, eax
    
   ;     CheckItema.   
   
    mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)           ;   
    invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                              sizeof(NONCLIENTMETRICS),\
                              addr ncinfo, 0                                      ;  ,    
    
 
    .if ncinfo.lfMenuFont.lfHeight > -15
        mov ncinfo.lfMenuFont.lfHeight, -15
    .endif

;   mov ncinfo.lfMenuFont.lfWidth, 14
    
    mov ncinfo.lfMenuFont.lfCharSet, DEFAULT_CHARSET
    
    invoke memfill, ADDR ncinfo.lfMenuFont.lfFaceName, LF_FACESIZE, 0
    invoke szCopy, ADDR szGlyphFont, ADDR ncinfo.lfMenuFont.lfFaceName                             
    invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont
       
    mov hGlyphFont, eax             ;   


    invoke DrawRctCheckXNET, hDC, lpRect, WidthBorder, State
    mov ebx, lpRect
    mov eax, [ebx].RECT.left        ;   
    mov RctCheck.left, eax
    mov eax, [ebx].RECT.top
    mov RctCheck.top, eax
    mov eax, [ebx].RECT.left
    add eax, WidthBorder
    mov RctCheck.right, eax
    mov eax, [ebx].RECT.bottom
    mov RctCheck.bottom, eax
   
;-------------- -------------------------------------------------
    
    invoke SetBkMode,hDC,TRANSPARENT
    invoke SelectObject, hDC, hGlyphFont
    mov OldFont, eax
    
    .if CheckMark               
        mov GlyphArray, 69h         ; Bullet
    .else
        add RctCheck.top, 1  
        mov GlyphArray, 62h         ; Checkmark
    .endif 
                               
    invoke DrawText, hDC,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER or DT_SINGLELINE   
    
    invoke SelectObject, hDC, OldFont   ;       
    invoke DeleteObject, hGlyphFont
    
    ret
DrawCheckXNET endp

DrawRctCheckXNET proc uses ebx hDC:HDC, lpRect:DWORD, WidthBorder:DWORD, State:BYTE

LOCAL RctCheck              :RECT
LOCAL hPen                  :HPEN
LOCAL hBrush                :HBRUSH    ;   CheckItema
LOCAL OldPen                :HPEN      ;     
LOCAL OldBrush              :HBRUSH
LOCAL colorSel              :COLORREF
LOCAL colorBorder           :COLORREF
LOCAL clr_start             :COLORREF
LOCAL clr_end               :COLORREF

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    call GetXpHighlightColor
    mov colorSel, eax

    mov ebx, lpRect
    mov eax, [ebx].RECT.left        ;   
    mov RctCheck.left, eax
    mov eax, [ebx].RECT.top
    mov RctCheck.top, eax
    mov eax, [ebx].RECT.left
    add eax, WidthBorder
    mov RctCheck.right, eax
    mov eax, [ebx].RECT.bottom
    mov RctCheck.bottom, eax
    
;--------------      ------------------
    
    xor eax, eax                    ;  
    mov al, State 
    and al, GRAY or SELECT or UNSELECT

    .if al == GRAY    
    
        call NumColorBits
        .if eax > 8
            ;        CheckItema        
            invoke MixedColor, colorSel, colorBorder
            invoke LightenColor, 128, eax
            mov clr_end, eax
            invoke DarkenColor, 24, colorSel
            mov clr_start, eax

;            mov clr_start, $invoke ( GetSysColor, COLOR_MENU )
;            mov clr_end, $invoke ( GetSysColor, COLOR_GRAYTEXT ) 
      
            invoke MixedColor, clr_start, clr_end
            invoke DarkenColor, 64, eax
            invoke CreateSolidBrush, eax
            mov hBrush, eax
        .else
            invoke CreateSolidBrush, $invoke ( GetSysColor, COLOR_MENU )
            mov hBrush, eax
            invoke CreatePen,PS_SOLID,1, $invoke ( GetSysColor, COLOR_GRAYTEXT )
            mov hPen, eax             
        .endif
        
;        jmp no_frame
        
    .elseif al == SELECT

        call NumColorBits
        .if eax > 8
            ;       CheckItema   
            invoke LightenColor, 128, colorSel
            mov clr_end, eax
            invoke DarkenColor, 48, colorSel
            mov clr_start, eax
            invoke MixedColor, clr_start, clr_end
            invoke DarkenColor, 64, eax
            invoke CreateSolidBrush, eax
            mov hBrush, eax
        .else
            invoke CreateSolidBrush, colorSel
            mov hBrush, eax
            invoke CreatePen,PS_SOLID,1, colorBorder
            mov hPen, eax         
        .endif 
     
    .elseif al == UNSELECT

        call NumColorBits
        .if eax > 8
            ;     CheckItema   .    
            invoke LightenColor, 200, colorSel
            mov clr_end, eax
            invoke DarkenColor, 24, colorSel
            mov clr_start, eax
            invoke MixedColor, clr_start, clr_end
            invoke DarkenColor, 64, eax
            invoke CreateSolidBrush, eax
            mov hBrush, eax
        .else
            invoke CreateSolidBrush, $invoke ( GetSysColor, COLOR_MENU )
            mov hBrush, eax
            invoke CreatePen,PS_SOLID,1, colorSel
            mov hPen, eax        
        .endif 
            
    .endif    

;--------------  CheckItema----------------------------------------

    call NumColorBits
    .if eax > 8
        invoke Gradient_Fill, hDC, ADDR RctCheck, clr_start, clr_end,  RECT_V
        invoke FrameRect, hDC, ADDR RctCheck, hBrush
    .else
        mov OldPen, $invoke ( SelectObject, hDC, hPen )
        mov OldBrush, $invoke ( SelectObject, hDC, hBrush )
        invoke Rectangle,hDC,RctCheck.left,RctCheck.top,
                         RctCheck.right,RctCheck.bottom
        invoke SelectObject, hDC, OldBrush                 
    .endif
  
    invoke DeleteObject, hBrush
    call NumColorBits
    .if eax <= 8
        invoke SelectObject, hDC, OldPen   
        invoke DeleteObject, hPen
    .endif

    ret
DrawRctCheckXNET endp