comment $
//-----------------------------------------------------------------------------------//
//  Source code                                                                      //
//                                                                                   //
//  Written      by  Chib                            			                     //
//                                                                                   //
//  FileName   : XXButton.asm                                                        //
//  Description: functions for work with BUTTON control                              //
//                                                                                   //
//  email      : XXControls@bk.ru                                                    //
//  website    : http://chib.boom.ru                                                 //
//-----------------------------------------------------------------------------------//
$
    
;--------------------------------------------------------------------------
.code

; #########################################################################
;                                                                         ;
;    .                                   ;
;                                                                         ;
; #########################################################################    

WndProc_Btn proc uses ebx hBtn:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL OldWndProc :SDWORD
    LOCAL Rct        :RECT
    LOCAL lpBtnStruct:DWORD
    LOCAL tme        :TRACKMOUSEEVENT
    LOCAL pt         :POINT
    LOCAL x_m        :DWORD
    LOCAL y_m        :DWORD
    LOCAL ti         :TOOLINFO
    LOCAL hwnd_next  :HWND
    LOCAL tmp        :DWORD

    invoke GetProp, hBtn, ADDR szProp_OldWndProc
    mov OldWndProc, eax
    
    .if uMsg == WM_MOUSEMOVE      
 
        invoke GetProp, hBtn, ADDR szProp_Struct
        .if eax
            mov ebx, eax
        .else
            jmp d_c
        .endif
      
        .if hBtnMouseHover == FALSE
        
            call ReleaseCapture         ; for menu button
        
;        PrintDec hBtn, " "
        	
        	.if [ebx].XXBUTTON_2.hCursor_hover
                invoke SetClassLong, hBtn, GCL_HCURSOR, [ebx].XXBUTTON_2.hCursor_hover
                mov OldCursor, eax
            .endif
           
           m2m hBtnMouseHover, hBtn
           
           ;    -|
           .if [ebx].XXBUTTON_2.hIcon_hover || ([ebx].XXBUTTON_2.btn_prop & FLAT_BTN) || [ebx].XXBUTTON_2.hover_clr || [ebx].XXBUTTON_2.hFont_hover || [ebx].XXBUTTON_2.hBitmap_hover
       	        invoke InvalidateRect, hBtn, NULL, FALSE
           .endif 
            
           .if [ebx].XXBUTTON_2.Sound_hover 
                invoke PlaySound, [ebx].XXBUTTON_2.Sound_hover, NULL, SND_MEMORY+SND_NOSTOP+SND_NOWAIT       
           .endif
        	
        	mov		tme.cbSize, sizeof(TRACKMOUSEEVENT)
        	mov		tme.dwFlags, TME_LEAVE
        	mov		tme.dwHoverTime, HOVER_DEFAULT
        	m2m		tme.hwndTrack, hBtn
        	invoke	TrackMouseEvent,addr tme

            .if [ebx].XXBUTTON_2.lpToolTip
   
                invoke SetTimer, hBtn, 1, 2000, ADDR TmrToolProcPre
                mov TimerID,eax
                   
            .endif

        .endif
        
        jmp d_c

    .elseif uMsg == WM_MOUSELEAVE 
 
        invoke GetProp, hBtn, ADDR szProp_Struct
        .if eax
            mov ebx, eax
        .else
            jmp d_c
        .endif
    	
    	.if OldCursor ;&& [ebx].XXBUTTON_2.hCursor_hover    	    
            invoke SetClassLong, hBtn, GCL_HCURSOR, OldCursor
            mov OldCursor, NULL
        .endif  
 
;        PrintDec hBtn, " "
        mov hBtnMouseHover, FALSE
        
        .if [ebx].XXBUTTON_2.hIcon_hover || ([ebx].XXBUTTON_2.btn_prop & FLAT_BTN) || [ebx].XXBUTTON_2.hover_clr || [ebx].XXBUTTON_2.hFont_hover || [ebx].XXBUTTON_2.hBitmap_hover                      
            invoke InvalidateRect, hBtn, NULL, FALSE
       .endif 
       
        mov		tme.cbSize, sizeof(TRACKMOUSEEVENT)
        mov		tme.dwFlags, TME_CANCEL
        mov		tme.dwHoverTime, HOVER_DEFAULT
        m2m		tme.hwndTrack, hBtn
        invoke	TrackMouseEvent,addr tme
        
         ; /* INITIALIZE MEMBERS OF THE TOOLINFO STRUCTURE */
        mov ti.cbSize, sizeof(TOOLINFO)
        mov ti.uFlags, TTF_TRACK+TTF_ABSOLUTE+TTF_IDISHWND
        m2m ti.hWnd, hwndTT
        m2m ti.hInst, hInst
        m2m ti.uId, hwndTT
        invoke SendMessage, hwndTT, TTM_TRACKACTIVATE, FALSE, ADDR ti
        invoke DestroyWindow, hwndTT
        invoke KillTimer, hBtn, TimerID            
            
        jmp d_c

    .elseif uMsg == WM_LBUTTONDBLCLK
        invoke SendMessage, hBtn, WM_LBUTTONDOWN, wParam, lParam
         
        jmp d_c
        
    .elseif uMsg == WM_LBUTTONDOWN

;        PrintDec hBtn,"WM_LBUTTONDOWN"   

        invoke GetProp, hBtn, ADDR szProp_Struct
        .if eax
            mov ebx, eax
        .else
            jmp d_c
        .endif
               
        invoke IsMenu, [ebx].XXBUTTON_2.hMenu
        .if eax
         
           invoke GetCursorPos, ADDR pt
           invoke GetWindowRect, hBtn, ADDR Rct
           m2m x_m, Rct.left
           m2m y_m, Rct.bottom
           m2m Rct.left, Rct.right
           sub Rct.left, nDropBtnWidth 
           invoke PtInRect, ADDR Rct, pt.x, pt.y
            .if eax && !m_bMenuPushed
                
                m2m m_bMenuPushed, hBtn                
                invoke GetFocus
                .if hBtn != eax
                    invoke SetFocus, hBtn
                .endif

                .if [ebx].XXBUTTON_2.btn_prop & MNU_BOTTOMRIGHT
                     m2m x_m, Rct.left
                     m2m y_m, Rct.bottom
                .elseif [ebx].XXBUTTON_2.btn_prop & MNU_RIGHT
                     m2m x_m, Rct.right
                     m2m y_m, Rct.top             
                .endif            
         
                invoke GetParent, hBtn
                mov tmp, eax                
                invoke TrackPopupMenu , [ebx].XXBUTTON_2.hMenu, TPM_LEFTALIGN+TPM_LEFTBUTTON, x_m, y_m, 0, tmp, 0
;                PrintDec eax  
;                call ReleaseCapture
                invoke SetCapture, hBtn
                
                invoke InvalidateRect, hBtn, NULL, TRUE
                              
            .elseif m_bMenuPushed 
            
                call ReleaseCapture
                mov m_bMenuPushed, NULL
                invoke InvalidateRect, hBtn, NULL, TRUE

            .else                
             
;                call ReleaseCapture
;                mov m_bMenuPushed, NULL
;                invoke InvalidateRect, hBtn, NULL, TRUE

                jmp d_c
;                
            .endif
           
        .else
     
;           invoke ReleaseCapture 
;           mov m_bMenuPushed, NULL
;           invoke InvalidateRect, hBtn, NULL, TRUE  
           jmp d_c        
    	.endif
 
    .elseif uMsg == BM_SETCHECK

        invoke GetProp, hBtn, ADDR szProp_Struct
        .if eax
            mov ebx, eax
        .else
            jmp d_c
        .endif

        .if [ebx].XXBUTTON_2.CheckStyle
        
            .if wParam == BST_CHECKED            
                cmp [ebx].XXBUTTON_2.CheckStyle, BS_AUTORADIOBUTTON
                jne no_radio
                m2m hwnd_next, hBtn 
next_item:      invoke GetParent, hBtn
                invoke GetNextDlgGroupItem, eax, hwnd_next, FALSE 
                mov hwnd_next, eax
                .if eax == hBtn || !hwnd_next 
                    jmp no_radio
                .endif
                invoke SendMessage, hwnd_next, BM_SETCHECK, BST_UNCHECKED, NULL
                jmp next_item
no_radio:           
                mov [ebx].XXBUTTON_2.CheckState, BST_CHECKED
            .else
                mov [ebx].XXBUTTON_2.CheckState, BST_UNCHECKED
            .endif 

        .endif
        invoke InvalidateRect, hBtn, NULL, TRUE
        jmp d_c
    .elseif uMsg == BM_GETCHECK

        invoke GetProp, hBtn, ADDR szProp_Struct
        .if eax
            mov ebx, eax
        .else
            jmp d_c
        .endif
        return [ebx].XXBUTTON_2.CheckState
        jmp d_c
        
    .elseif uMsg == WM_ERASEBKGND
        mov eax, TRUE
        ret
;    	jmp d_c 
    .elseif uMsg == WM_LBUTTONUP    	

        invoke GetProp, hBtn, ADDR szProp_Struct
        .if eax
            mov ebx, eax
        .else
            jmp d_c
        .endif
           
        mov eax, hBtn
        .if hBtnMouseHover != eax 
            invoke SendMessage, hBtn, WM_MOUSEMOVE, 0, 0
        .else           
            invoke GetCursorPos, ADDR pt
            invoke GetWindowRect, hBtn, ADDR Rct
            invoke IsMenu, [ebx].XXBUTTON_2.hMenu     ;   ,       	
            .if eax
                sub Rct.right, nDropBtnWidth                   
            .endif
            invoke PtInRect, ADDR Rct, pt.x, pt.y
            cmp eax, FALSE
            je @f
        
            .if [ebx].XXBUTTON_2.CheckStyle == BS_AUTOCHECKBOX
            
                .if [ebx].XXBUTTON_2.CheckState == BST_CHECKED
                    invoke SendMessage, hBtn, BM_SETCHECK, BST_UNCHECKED, 0
                .else
                    invoke SendMessage, hBtn, BM_SETCHECK, BST_CHECKED, 0
                .endif
                   
            .elseif [ebx].XXBUTTON_2.CheckStyle == BS_AUTORADIOBUTTON || [ebx].XXBUTTON_2.CheckStyle == BS_RADIOBUTTON
            
                invoke SendMessage, hBtn, BM_SETCHECK, BST_CHECKED, 0
                
            .endif
@@:           
        .endif 
        
        jmp d_c
        
    .elseif uMsg == WM_KEYUP && wParam == VK_SPACE

        invoke GetProp, hBtn, ADDR szProp_Struct
        .if eax
            mov ebx, eax
        .else
            jmp d_c
        .endif
        
        .if [ebx].XXBUTTON_2.CheckStyle == BS_AUTOCHECKBOX
        
        .if [ebx].XXBUTTON_2.CheckState == BST_CHECKED
            invoke SendMessage, hBtn, BM_SETCHECK, BST_UNCHECKED, 0
        .else
            invoke SendMessage, hBtn, BM_SETCHECK, BST_CHECKED, 0
        .endif
        
        .elseif [ebx].XXBUTTON_2.CheckStyle == BS_AUTORADIOBUTTON || [ebx].XXBUTTON_2.CheckStyle == BS_RADIOBUTTON
        
            invoke SendMessage, hBtn, BM_SETCHECK, BST_CHECKED, 0
        
        .endif
        
        jmp d_c        
           
    .elseif uMsg == WM_DESTROY ;|| uMsg == WM_CLOSE

;        PrintDec uMsg, "DESTROY"

        mov		tme.cbSize, sizeof(TRACKMOUSEEVENT)
        mov		tme.dwFlags, TME_CANCEL
        mov		tme.dwHoverTime, HOVER_DEFAULT
        m2m		tme.hwndTrack, hBtn
        invoke	TrackMouseEvent,addr tme
        
        mov hBtnMouseHover, FALSE        
        
        invoke FreeXXStruct, hBtn
        jmp d_c        
        
    .else

d_c:        
        invoke CallWindowProc,OldWndProc,hBtn,uMsg,wParam,lParam
;        PrintDec eax
        ret
    .endif           
 
    xor eax,eax
    ret
WndProc_Btn endp

; #########################################################################
;                                                                         ;
;   WM_DRAWITEM ( Normal)                          ;
;                                                                         ;
; #########################################################################

DrawItem_Btn proc

LOCAL TxtLenght :DWORD
LOCAL TextBtn   :DWORD
LOCAL RctBtn    :RECT
LOCAL RctIcn    :RECT
LOCAL RctTxt    :RECT
LOCAL RctFocus  :RECT
LOCAL RctMnuBtn :RECT
LOCAL hIcon     :HICON
LOCAL tmp       :DWORD
LOCAL tmp2      :DWORD
LOCAl hBmpDDB   :HBITMAP
LOCAL btnState  :DWORD
LOCAL cr        :COLORREF
LOCAL hPenSplit :HPEN
LOCAL hPenOld   :HPEN
LOCAL hParentDC :HDC
LOCAL hWndParent:HWND
LOCAL OldWndProc :DWORD
LOCAL hBtnDC    :HDC
LOCAL hBtnBmp   :HBITMAP
LOCAL hOldBtnBmp:HBITMAP

LOCAL hMemDC    :HDC
LOCAL hMemBMP   :HBITMAP
LOCAL hOldMemBMP:HBITMAP
LOCAL Rct       :RECT
LOCAL nWidth    :DWORD
LOCAL nHeight   :DWORD
LOCAl clr_start, clr_end    :COLORREF


; ======================================================================

assume ebx: ptr DRAWITEMSTRUCT
assume esi: ptr XXBUTTON_2  

    mov hBtnDC, $invoke (CreateCompatibleDC, [ebx].hdc)
    mov hBtnBmp, $invoke (CreateCompatibleBitmap, [ebx].hdc, [ebx].rcItem.right, [ebx].rcItem.bottom)
    mov hOldBtnBmp, $invoke (SelectObject, hBtnDC, hBtnBmp)
    invoke SetBkMode, hBtnDC, TRANSPARENT 
    invoke GetStockObject, DEFAULT_GUI_FONT   
    invoke SelectObject, [ebx].hdc, eax
    push eax
    invoke SelectObject, hBtnDC, eax
    ;  ,    
    push [ebx].hdc
    call SelectObject
    
    invoke GetWindowTextLength, [ebx].hwndItem
    inc eax
    mov TxtLenght, eax
    
    invoke GlobalAlloc, GPTR, TxtLenght         ; 
    mov TextBtn, eax
    invoke GetWindowText, [ebx].hwndItem, TextBtn, TxtLenght

    invoke CopyRect, ADDR RctBtn, ADDR [ebx].rcItem
    
    .if [esi].hMenu
        sub [ebx].rcItem.right, nDropBtnWidth    
    .endif
    
        invoke CopyRect, ADDR RctIcn, ADDR [ebx].rcItem
        invoke CopyRect, ADDR RctTxt, ADDR [ebx].rcItem
        invoke CopyRect, ADDR RctFocus, ADDR [ebx].rcItem

        .if ([esi].btn_prop & DRAW_BORDER)
            invoke InflateRect, ADDR RctTxt, -2, -2
            invoke InflateRect, ADDR RctIcn, -2, -2
        .endif
         
        .if ([esi].btn_prop & DRAW_FOCUS)
            invoke InflateRect, ADDR RctTxt, -2, -2
            invoke InflateRect, ADDR RctIcn, -2, -2
        .endif 

    .if [esi].hMenu
        add [ebx].rcItem.right, nDropBtnWidth    
    .endif
    
    invoke CopyRect, ADDR RctMnuBtn, ADDR [ebx].rcItem
    m2m RctMnuBtn.left, RctMnuBtn.right
    sub RctMnuBtn.left, nDropBtnWidth

    mov hIcon, NULL
    mov btnState, BTN_STATE_NORMAL
    
    .if !([esi].btn_prop & STYLE_OFFICE_XP) || !([esi].btn_prop & STYLE_XNET)
        .if !([esi].btn_prop & TRANSPARENT_BKGND)
            invoke FillRect, hBtnDC, ADDR RctBtn, COLOR_BTNFACE+1
        .else
            invoke GetParent, [ebx].hwndItem
            mov hWndParent, eax
            ;invoke SendMessage, hWndParent, WM_ERASEBKGND, hBtnDC, 0        
            invoke GetClientRect, hWndParent, ADDR Rct
            mov eax, Rct.right
            sub eax, Rct.left
            mov nWidth, eax 
            
            mov eax, Rct.bottom
            sub eax, Rct.top
            mov nHeight, eax
            invoke CreateCompatibleDC, hBtnDC
            mov hMemDC, eax
            invoke CreateCompatibleBitmap, hBtnDC, nWidth, nHeight  
            mov hMemBMP, eax
            invoke SelectObject, hMemDC, hMemBMP
            mov hOldMemBMP, eax
            invoke SendMessage, hWndParent, WM_ERASEBKGND, hMemDC, 0
            invoke GetWindowRect, [ebx].hwndItem, ADDR Rct       
            invoke ScreenToClient, hWndParent, ADDR Rct
            
            invoke BitBlt, hBtnDC, [ebx].rcItem.left, [ebx].rcItem.top, [ebx].rcItem.right, [ebx].rcItem.bottom, hMemDC, Rct.left, Rct.top, SRCCOPY
    
            invoke SelectObject, hMemDC, hOldMemBMP 
            invoke DeleteObject, hMemBMP
            invoke DeleteDC, hMemDC
        .endif
    .endif

    .if [ebx].itemState & ODS_SELECTED         ; SELECTED (DOWN) BUTTON

        mov btnState, BTN_STATE_PUSH

        ;       
        .if [esi].btn_prop & STYLE_OFFICE_XP
            
            invoke DrawXPButton, hBtnDC, ADDR RctBtn, byte ptr btnState

        .elseif [esi].btn_prop & STYLE_XNET
 
            invoke DrawXNETButton, hBtnDC, ADDR RctBtn, byte ptr btnState

;            .elseif [esi].btn_prop & WINXP_THEME_ON
;    
;                .if !hDllUxTheme        
;                    mov hDllUxTheme, $invoke (LoadLibrary, ADDR szUxTheme)
;                .endif
            

        .elseif [esi].btn_prop & STYLE_OFFICE_2000

            .if ([esi].btn_prop & DRAW_BORDER)             
                    mov clr_start, $invoke (GetSysColor, COLOR_BTNSHADOW)
                    mov clr_end, $invoke (GetSysColor, COLOR_BTNHIGHLIGHT)
                    invoke Draw3dRect, hBtnDC, ADDR RctBtn, clr_start, clr_end                
            .endif
            jmp @f
        
        .else   ;   ( )

            .if ([esi].btn_prop & DRAW_BORDER)                  ; paint border???
            
                invoke DrawEdge, hBtnDC, ADDR RctBtn, EDGE_SUNKEN,BF_RECT
                ;invoke DrawFrameControl, hBtnDC, ADDR RctBtn, DFC_BUTTON, DFCS_BUTTONPUSH+DFCS_PUSHED
            
            .endif
@@:            
            invoke OffsetRect, ADDR RctIcn, 1, 1    ;  
            .if ([esi].btn_prop & DRAW_BORDER)         
                invoke OffsetRect, ADDR RctTxt, 1, 1    ;  
            .endif
    
        .endif        
         
    .else
        ;   
        mov eax, hBtnMouseHover
        .if eax == [ebx].hwndItem
            mov btnState, BTN_STATE_HOVER
        .else
            mov btnState, BTN_STATE_NORMAL
        .endif
        
        ;       
        .if [esi].btn_prop & STYLE_OFFICE_XP
            
            .if [esi].CheckState
                mov btnState, BTN_STATE_PUSH
            .endif            
            
            invoke DrawXPButton, hBtnDC, ADDR RctBtn, byte ptr btnState
                        
        .elseif [esi].btn_prop & STYLE_XNET

            .if [esi].CheckState
                mov btnState, BTN_STATE_PUSH
            .endif

            invoke DrawXNETButton, hBtnDC, ADDR RctBtn, byte ptr btnState

        .elseif [esi].btn_prop & STYLE_OFFICE_2000

            .if ([esi].btn_prop & DRAW_BORDER)
                .if (([esi].btn_prop & FLAT_BTN) && (btnState == BTN_STATE_HOVER)) || !([esi].btn_prop & FLAT_BTN)
                
                        .if [esi].CheckState
                            mov clr_start, $invoke (GetSysColor, COLOR_BTNSHADOW)
                            mov clr_end, $invoke (GetSysColor, COLOR_BTNHIGHLIGHT)
                            invoke Draw3dRect, hBtnDC, ADDR RctBtn, clr_start, clr_end                   
                        .else
                            mov clr_start, $invoke (GetSysColor, COLOR_BTNHIGHLIGHT)
                            mov clr_end, $invoke (GetSysColor, COLOR_BTNSHADOW)
                            invoke Draw3dRect, hBtnDC, ADDR RctBtn, clr_start, clr_end
                        .endif                
                .endif            
            .endif 

        .else   ;   ( )
              
            .if ([esi].btn_prop & DRAW_BORDER)
                .if (([esi].btn_prop & FLAT_BTN) && btnState == BTN_STATE_HOVER) || !([esi].btn_prop & FLAT_BTN)
                
                        .if [esi].CheckState
                            invoke DrawEdge, hBtnDC, ADDR RctBtn, EDGE_SUNKEN,BF_RECT                    
                        .else
                           invoke DrawEdge, hBtnDC, ADDR RctBtn, EDGE_RAISED,BF_RECT
                           ;invoke DrawFrameControl, hBtnDC, ADDR RctBtn, DFC_BUTTON, DFCS_BUTTONPUSH+DFCS_TRANSPARENT
                        .endif                
                .endif            
            .endif              
                            
        .endif
        
        .if [esi].CheckState
            mov btnState, BTN_STATE_PUSH
        .endif

   .endif 
            
    .if [ebx].itemState & ODS_DISABLED    
        mov btnState, BTN_STATE_GRAY
        invoke GetSysColor, COLOR_GRAYTEXT
        invoke SetTextColor, hBtnDC, eax
        .if [esi].hIcon_normal
            m2m hIcon, [esi].hIcon_normal
        .endif
    .else
       
        .if [esi].hIcon_hover && (btnState == BTN_STATE_HOVER || btnState == BTN_STATE_PUSH)
            m2m hIcon, [esi].hIcon_hover
        .elseif [esi].hIcon_normal
            m2m hIcon, [esi].hIcon_normal
        .endif
        
        ;       
        .if [esi].push_clr && btnState == BTN_STATE_PUSH
        
            invoke SetTextColor, hBtnDC, [esi].push_clr
        
        .elseif [esi].hover_clr && btnState == BTN_STATE_HOVER
       
            invoke SetTextColor, hBtnDC, [esi].hover_clr
        
        .elseif [esi].normal_clr
        
            invoke SetTextColor, hBtnDC, [esi].normal_clr
       
       .else 
            invoke GetSysColor,COLOR_BTNTEXT
            invoke SetTextColor, hBtnDC, eax
       .endif
                
    .endif    
    
    .if [esi].hFont_hover && (btnState == BTN_STATE_HOVER || btnState == BTN_STATE_PUSH)
        invoke SelectObject, hBtnDC, [esi].hFont_hover
    .elseif [esi].hFont_normal
        invoke SelectObject, hBtnDC, [esi].hFont_normal
    .endif
    
    ; draw icon and text
    .if hIcon && TxtLenght > 1         ; ICON + TEXT
    
        .if [esi].btn_prop & ICON_LEFT
        
bsleft:    
                mov eax, RctIcn.right
                sub eax, RctIcn.left    
                invoke IntDiv, eax, 3
    
                mov RctIcn.right, eax               ; icon = 1/3                
                
                mov eax, RctTxt.right
                sub eax, RctTxt.left
                shr eax, 2    
                ;invoke IntDiv, eax, 4
                
                add RctTxt.left, eax                ; text = 3/4
            
        .elseif [esi].btn_prop & ICON_RIGHT
        
                mov eax, RctIcn.right
                sub eax, RctIcn.left    
                invoke IntDiv, eax, 3
          
                m2m RctIcn.left, RctIcn.right
                sub RctIcn.left, eax                ; icon = 1/3
                
                mov eax, RctTxt.right
                sub eax, RctTxt.left
                shr eax, 2    
                ;invoke IntDiv, eax, 4                
                
                sub RctTxt.right, eax               ; text = 3/4
        
        .elseif [esi].btn_prop & ICON_TOP
        
                mov eax, RctIcn.bottom
                sub eax, RctIcn.top   
                invoke IntDiv, eax, 3
        
                sub RctIcn.bottom, eax      ; icon = 2/3
                
                mov eax, RctTxt.bottom
                sub eax, RctTxt.top
                shr eax, 1    
                ;invoke IntDiv, eax, 2
                
                add RctTxt.top, eax         ; text = 1/2
                
        .else
                
                jmp bsleft        
        .endif
        
;    .elseif hIcon && TxtLenght <= 1        ; ONLY ICON
;        
;    
;    .elseif !hIcon && TxtLenght > 1        ; ONLY TEXT
   
    .endif

            
    .if btnState == BTN_STATE_NORMAL && [esi].hBitmap_normal
    
        m2m hBmpDDB, [esi].hBitmap_normal
        jmp @f
        
    .elseif btnState == BTN_STATE_HOVER && [esi].hBitmap_hover 
    
        m2m hBmpDDB, [esi].hBitmap_hover
        jmp @f
        
    .elseif btnState == BTN_STATE_PUSH && [esi].hBitmap_push 

        m2m hBmpDDB, [esi].hBitmap_push
        jmp @f
        
    .elseif btnState == BTN_STATE_GRAY && [esi].hBitmap_gray    
        
        m2m hBmpDDB, [esi].hBitmap_gray
@@: 
        .if ([esi].btn_prop & DRAW_BORDER)
            .if [esi].btn_prop & STYLE_OFFICE_2000           
                invoke InflateRect, ADDR RctBtn, -1, -1
            .else
                invoke InflateRect, ADDR RctBtn, -2, -2
            .endif
        .endif
        mov eax, [esi].btn_prop
        and eax, RGN_BUTTON
        invoke DrawDDB, hBtnDC, ADDR RctBtn, hBmpDDB, eax
        .if ([esi].btn_prop & DRAW_BORDER)
            .if [esi].btn_prop & STYLE_OFFICE_2000           
                invoke InflateRect, ADDR RctBtn, 1, 1
            .else
                invoke InflateRect, ADDR RctBtn, 2, 2
            .endif
        .endif
                        
    .endif
    
    .if hIcon
        ; DRAW ICON
        .if btnState == BTN_STATE_GRAY
            invoke DrawIcnRect, hBtnDC, ADDR RctIcn, hIcon, GRAY, FALSE
        .else
        
            ;   .   
            .if ([esi].btn_prop & STYLE_XNET) || ([esi].btn_prop & STYLE_OFFICE_XP) && (btnState == BTN_STATE_HOVER || btnState == BTN_STATE_PUSH)
                invoke Icon_CopyAsBlend, [ebx].hdc, hIcon, 64
                mov hIcon, eax
            .endif
            invoke DrawIcnRect, hBtnDC, ADDR RctIcn, hIcon, NULL, FALSE
             .if ([esi].btn_prop & STYLE_XNET) || ([esi].btn_prop & STYLE_OFFICE_XP)  && (btnState == BTN_STATE_HOVER || btnState == BTN_STATE_PUSH)
                invoke DestroyIcon, hIcon
            .endif
        .endif
    .endif  
    
    .if TxtLenght > 1
       dec TxtLenght
       invoke CopyRect, ADDR Rct, ADDR RctTxt
       invoke DrawText, hBtnDC, TextBtn, TxtLenght, ADDR Rct, DT_WORDBREAK+DT_CALCRECT+DT_CENTER

       ; ((centerRect.Width() - rpCaption->Width())/2, (centerRect.Height() - rpCaption->Height())/2);       
;       mov eax, Rct.right
;       sub eax, Rct.left    
;       mov Rct.right, eax   ; Rct.right == Width Rct
       mov eax, Rct.bottom
       sub eax, Rct.top  
       mov Rct.bottom, eax  ; Rct.bottom == Height Rct
       
;       mov eax, RctTxt.right
;       sub eax, RctTxt.left
;       sub eax, Rct.right
;       shr eax, 1
;       mov Rct.right, eax
       
       mov eax, RctTxt.bottom
       sub eax, RctTxt.top
       sub eax, Rct.bottom
       shr eax, 1
       mov Rct.bottom, eax
       
       invoke OffsetRect, ADDR RctTxt, 0, Rct.bottom
       invoke DrawText, hBtnDC, TextBtn, TxtLenght, ADDR RctTxt, DT_WORDBREAK+DT_CENTER
    .endif
    
    .if [esi].hMenu
    
            mov eax, [ebx].hwndItem
            .if m_bMenuPushed != eax
            
                invoke GetSysColor, COLOR_3DSHADOW
                invoke CreatePen, PS_SOLID, 1, eax
                mov hPenSplit, eax
                invoke SelectObject, hBtnDC, hPenSplit
                mov hPenOld, eax
                
                ;add RctMnuBtn.left, 2
                add RctMnuBtn.top, 4
                sub RctMnuBtn.bottom, 4
                invoke MoveToEx, hBtnDC, RctMnuBtn.left, RctMnuBtn.top, NULL
                invoke LineTo, hBtnDC, RctMnuBtn.left, RctMnuBtn.bottom
                
                invoke GetSysColor, COLOR_3DHILIGHT
                invoke CreatePen, PS_SOLID, 1, eax
                mov hPenSplit, eax
                invoke SelectObject, hBtnDC, eax
                invoke DeleteObject, eax
    
                inc RctMnuBtn.left
                
                invoke MoveToEx, hBtnDC, RctMnuBtn.left, RctMnuBtn.top, NULL
                invoke LineTo, hBtnDC, RctMnuBtn.left, RctMnuBtn.bottom
    
                invoke SelectObject, hBtnDC, hPenOld
                invoke DeleteObject, eax
    
                dec RctMnuBtn.left
                ;sub RctMnuBtn.left, 2
                sub RctMnuBtn.top, 4
                add RctMnuBtn.bottom, 4
                
            .else
            
                invoke InflateRect, ADDR RctMnuBtn, 0, -3
                sub RctMnuBtn.right, 3
                invoke DrawEdge, hBtnDC, ADDR RctMnuBtn, BDR_SUNKENOUTER, BF_RECT
                add RctMnuBtn.right, 3
                invoke InflateRect, ADDR RctMnuBtn, 0, 3    
            
            .endif
    
    
            .if ([esi].btn_prop & MNU_BOTTOMRIGHT) || ([esi].btn_prop & MNU_BOTTOM)
                invoke DrawArrow, hBtnDC, ADDR RctMnuBtn, TRUE    
            .elseif ([esi].btn_prop & MNU_RIGHT)
                invoke DrawArrow, hBtnDC, ADDR RctMnuBtn, FALSE       
            .endif
       
    .endif
    
        ;      Fill rect
    
        .if [ebx].itemState & ODS_FOCUS && ([esi].btn_prop & DRAW_FOCUS)
            .if ([esi].btn_prop & DRAW_BORDER) || [esi].hBitmap_normal || [esi].hBitmap_push || [esi].hBitmap_hover
                invoke InflateRect, ADDR RctFocus, -4, -4
            .else
                invoke InflateRect, ADDR RctFocus, -1, -1 
            .endif
            
            invoke GetSysColor, COLOR_GRAYTEXT
            mov edx, eax
            push edx
            invoke GetSysColor, COLOR_BTNTEXT
            pop edx
            invoke MixedColor, edx, eax
            invoke LightenColor, 32, eax
            mov cr, eax
            
            mov eax, RctFocus.right
            sub eax, RctFocus.left
            mov tmp, eax
            mov eax, RctFocus.bottom
            sub eax, RctFocus.top
            mov tmp2, eax            

            inc RctFocus.left
            dec tmp
            invoke Line_dot, hBtnDC, RctFocus.left, RctFocus.top, tmp, TRUE, cr
            inc eax
            dec RctFocus.left
            
            dec tmp2
            inc RctFocus.top
            invoke Line_dot, hBtnDC, eax, RctFocus.top, tmp2, FALSE, cr
            invoke Line_dot, hBtnDC, RctFocus.left, RctFocus.top, tmp2, FALSE, cr
            
            inc eax
            inc RctFocus.left
            invoke Line_dot, hBtnDC, RctFocus.left, eax, tmp, TRUE, cr
            
        .endif    

    invoke GlobalFree, TextBtn     ; 

    invoke BitBlt, [ebx].hdc, 0, 0, [ebx].rcItem.right, [ebx].rcItem.bottom, hBtnDC, 0, 0,SRCCOPY
    invoke SelectObject, hBtnDC, hOldBtnBmp
    invoke DeleteObject, hBtnBmp
    invoke DeleteDC, hBtnDC

assume esi: nothing
assume ebx: nothing

   ret
DrawItem_Btn endp

DrawArrow proc hDC:HDC, lpRect:DWORD, MnuAlign:BYTE

LOCAL RctCheck              :RECT
LOCAL hGlyphFont            :HFONT
LOCAL GlyphArray[2]         :BYTE
LOCAL ncinfo                :NONCLIENTMETRICS
 
    
   ;     CheckItema.   
   
    mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)           ;   
    invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                              sizeof(NONCLIENTMETRICS),\
                              addr ncinfo, 0                                      ;  ,    
    
    .if ncinfo.lfMenuFont.lfHeight > -15
        mov ncinfo.lfMenuFont.lfHeight, -15
    .endif

;   mov ncinfo.lfMenuFont.lfWidth, 14

    mov ncinfo.lfMenuFont.lfCharSet, DEFAULT_CHARSET
    
    invoke memfill, ADDR ncinfo.lfMenuFont.lfFaceName, LF_FACESIZE, 0
    invoke szCopy, ADDR szGlyphFont, ADDR ncinfo.lfMenuFont.lfFaceName                             
    invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont
       
    mov hGlyphFont, eax             ;   
    
    invoke SetBkMode,hDC,TRANSPARENT
    invoke SelectObject, hDC, hGlyphFont
    push eax
    
    .if MnuAlign               
        mov GlyphArray, 36h         ; Bullet
    .else 
        mov GlyphArray, 34h         ; Checkmark
    .endif 
                               
    invoke DrawText, hDC, ADDR GlyphArray, 1, lpRect, DT_CENTER or DT_VCENTER or DT_SINGLELINE
    pop eax
    invoke SelectObject,hDC, eax            ;   

    invoke DeleteObject, hGlyphFont
    
    ret
DrawArrow endp

; #########################################################################
;                                                                         ;
;                                  ;
;                                                                         ;
; #########################################################################

TmrToolProc proc hWin:HWND,uMsg:UINT,idEvent:UINT,dwTime:DWORD

LOCAL ti     :TOOLINFO

    .if uMsg == WM_TIMER
        mov eax, idEvent
        .if eax == TimerID
        
            ; /* INITIALIZE MEMBERS OF THE TOOLINFO STRUCTURE */
            mov ti.cbSize, sizeof(TOOLINFO)
            mov ti.uFlags, TTF_TRACK+TTF_ABSOLUTE+TTF_IDISHWND
            m2m ti.hWnd, hwndTT
            m2m ti.hInst, hInst
            m2m ti.uId, hwndTT
            invoke SendMessage, hwndTT, TTM_TRACKACTIVATE, FALSE, ADDR ti
            invoke DestroyWindow, hwndTT
            invoke KillTimer, hWin, TimerID            
        .endif
    .endif
    
	ret
TmrToolProc endp

; #########################################################################
;                                                                         ;
;                                                         ;
;                                                                         ;
; #########################################################################

TmrToolProcPre proc uses ebx hWin:HWND,uMsg:UINT,idEvent:UINT,dwTime:DWORD

LOCAL ti         :TOOLINFO
LOCAL pt         :POINT
LOCAL StyleTool  :DWORD

    invoke GetProp, hWin, ADDR szProp_Struct
    mov ebx, eax

    .if uMsg == WM_TIMER
        mov eax, idEvent
        .if eax == TimerID
        
                invoke KillTimer, hWin, TimerID
                .if [ebx].XXBUTTON_2.btn_prop & BALLOON_TT
                        mov StyleTool, WS_POPUP+TTS_NOPREFIX+TTS_ALWAYSTIP+TTS_BALLOON
                .else
                        mov StyleTool, WS_POPUP+TTS_NOPREFIX+TTS_ALWAYSTIP    
                .endif
                ; /* CREATE A TOOLTIP WINDOW */
                invoke CreateWindowEx, WS_EX_TOPMOST, ADDR ToolClass, NULL, StyleTool,
                            CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                            hWin, NULL, hInst, NULL  
                mov hwndTT, eax
                invoke SetWindowPos, hwndTT, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE+SWP_NOSIZE+SWP_NOACTIVATE 
     
                ; /* INITIALIZE MEMBERS OF THE TOOLINFO STRUCTURE */
                mov ti.cbSize, sizeof(TOOLINFO)
                mov ti.uFlags, TTF_TRACK+TTF_ABSOLUTE+TTF_IDISHWND+TTF_TRANSPARENT
                m2m ti.hWnd, hWin
                m2m ti.hInst, hInst
                m2m ti.uId, hwndTT

                m2m ti.lpszText, [ebx].XXBUTTON_2.lpToolTip

                ; /* SEND AN ADDTOOL MESSAGE TO THE TOOLTIP CONTROL WINDOW */
                invoke SendMessage, hwndTT, TTM_ADDTOOL, 0, ADDR ti         
                
                invoke SendMessage, hwndTT, TTM_SETMAXTIPWIDTH, 0, 220
                
                invoke GetCursorPos, ADDR pt
                add pt.x, 10
                add pt.y, 20
                MAKEDWORD word ptr pt.x, word ptr pt.y
                invoke SendMessage, hwndTT, TTM_TRACKPOSITION, 0, eax
                
                invoke SendMessage, hwndTT, TTM_TRACKACTIVATE, TRUE, ADDR ti 
                invoke SetTimer, hWin, 1, TIME_TOOLTIP_BTN_SHOW, ADDR TmrToolProc
                mov TimerID,eax                                       
        .endif
    .endif
    
	ret
TmrToolProcPre endp

; #########################################################################
;                                                                         ;
;     OWNERDRAW                                ;
;                                                                         ;
; #########################################################################

BtnToOwnerdraw proc uses ebx hWin:HWND
    
    invoke GetWindowLong, hWin, GWL_STYLE
    .if !(eax & BS_OWNERDRAW) || !(eax & BS_PUSHBUTTON)
        push eax
        invoke GetProp, hWin, ADDR szProp_Struct
        mov ebx, eax
        pop eax
        mov [ebx].XXBUTTON_2.OldStyle, eax
        xor eax, BS_DEFPUSHBUTTON
        .if eax & BS_RADIOBUTTON
            xor eax, BS_RADIOBUTTON
        .endif
        or eax, BS_OWNERDRAW
        invoke SetWindowLong, hWin, GWL_STYLE, eax
    .endif     
    
    ret
BtnToOwnerdraw endp

; #########################################################################
;                                                                         ;
;     OWNERDRAW                                      ;
;                                                                         ;
; #########################################################################

OwnerdrawToBtn proc uses ebx hWin:HWND

    invoke GetProp, hWin, ADDR szProp_Struct
    mov ebx, eax     
    invoke SetWindowLong, hWin, GWL_STYLE, [ebx].XXBUTTON_2.OldStyle
    .if [ebx].XXBUTTON_2.CheckState && [ebx].XXBUTTON_2.CheckStyle
        invoke SendMessage, hWin, BM_SETCHECK, [ebx].XXBUTTON_2.CheckState, 0  
    .endif  

    ret
OwnerdrawToBtn endp

; #########################################################################
;                                                                         ;
;   XXBUTTON_2     .            ;
;                                                                         ;
; #########################################################################

SetStyleButton proc uses ebx hBtn :HWND, lpXXButton :DWORD

    invoke FreeXXStruct, hBtn

    invoke GlobalAlloc, GPTR, sizeof(XXBUTTON_2)         ; 

    mov ebx, eax
    invoke SetProp, hBtn, ADDR szProp_Struct, eax
    invoke MemCopy, lpXXButton, ebx, sizeof(XXBUTTON)
 
	ret
SetStyleButton endp

; #########################################################################
;                                                                         ;
;     XXBUTTON_2                       ;

;                                                                         ;
; #########################################################################

FreeXXStruct proc hBtn:HWND

    invoke GetProp, hBtn, ADDR szProp_Struct
    .if eax
        invoke GlobalFree, eax     ;    
    .endif
    invoke RemoveProp, hBtn, ADDR szProp_Struct 

	ret
FreeXXStruct endp

; =========================================================================
;                  
;
; #########################################################################
;                                                                         ;
;    .                                          ;  
;                                                                         ;
; #########################################################################

PUBLIC RedrawButton

RedrawButton proc hBtn:HWND, lpXXButton:DWORD
    
    invoke IsWindow, hBtn
    .if !eax
        return FALSE
    .endif

    .if lpXXButton
   
        .if !hInst
            invoke GetModuleHandle, NULL
            mov hInst, eax        
        .endif
   
        invoke SetStyleButton, hBtn, lpXXButton
        invoke SetCheckBoxStyle, hBtn
        invoke BtnToOwnerdraw, hBtn
        invoke GetParent, hBtn
        invoke SetNewWndProc, eax, ADDR szProp_OldWndProc, ADDR XXWndProc
        invoke SetNewWndProc, hBtn, ADDR szProp_OldWndProc, ADDR WndProc_Btn        
        
        mov eax, lpXXButton
        .if ([eax].XXBUTTON_2.btn_prop & RGN_BUTTON) && [eax].XXBUTTON_2.hBitmap_normal
            ;     ,     
            ;     ,    
            invoke CreateRgnFromBitmap, [eax].XXBUTTON_2.hBitmap_normal
            push eax
            invoke SetWindowRgn, hBtn, eax, FALSE
            call DeleteObject  
        .endif
        
    .else
    
        invoke SetWindowRgn, hBtn, NULL, FALSE    
        invoke OwnerdrawToBtn, hBtn
        ;invoke SetOldWndProc, hBtn, ADDR WndProc_Btn, ADDR szProp_OldWndProcBtn        
        invoke FreeXXStruct, hBtn
        
    .endif
    
    mov eax, TRUE
    ret
RedrawButton endp

SetCheckBoxStyle proc uses ebx hBtn:HWND

    invoke GetProp, hBtn, ADDR szProp_Struct
    mov ebx, eax
    invoke GetWindowLong, hBtn, GWL_STYLE   
    xor edx, edx
    mov edx, BS_AUTOCHECKBOX or BS_RADIOBUTTON or BS_AUTORADIOBUTTON or BS_CHECKBOX
    and eax, edx
    .if eax
        mov [ebx].XXBUTTON_2.CheckStyle, eax
        invoke SendMessage, hBtn, BM_GETCHECK, 0, 0    
        mov [ebx].XXBUTTON_2.CheckState, eax       
    .endif
    
	ret
SetCheckBoxStyle endp