comment $
//-----------------------------------------------------------------------------------//
//  Source code                                                                      //
//                                                                                   //
//  Written      by  Chib                            			                     //
//                                                                                   //
//  FileName   : XXMenu.asm                                                          //
//  Description: functions for work with menu                                        //
//                                                                                   //
//  email      : XXControls@bk.ru                                                    //
//  website    : http://chib.boom.ru                                                 //
//-----------------------------------------------------------------------------------//
$
    
;--------------------------------------------------------------------------
.code

; #########################################################################
;                                                                         ;
;                         ;
;                                                                         ;
; #########################################################################    

WndProc_Menu proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL OldhMenu   :HMENU
LOCAL OldWndProc :DWORD
;LOCAL hMenuWnd   :DWORD

;LOCAL Rct        :RECT
;LOCAL pt         :POINT
;LOCAL x_m        :DWORD
;LOCAL y_m        :DWORD

    invoke GetProp, hWin, ADDR szProp_OldWndProcMenu
    mov OldWndProc, eax

    .if uMsg == WM_INITMENUPOPUP    
            
;        PrintDec wParam, "WM_INITMENUPOPUP"
        m2m hMenuForMeasure, wParam

        .if !hMenu && !fAccel
            
            m2m hMenu, wParam
            .if fTransparent
            
                ; Toggle menu fading/animation mode (Windows2K or later)
                mov bMenuFading, FALSE
                mov bMenuAnim, FALSE         
            
                invoke SystemParametersInfo, SPI_GETMENUFADE, 0, ADDR bMenuFading, 0
            	invoke SystemParametersInfo, SPI_GETMENUANIMATION, 0, ADDR bMenuAnim, 0				
            	.if bMenuFading
            	    invoke SystemParametersInfo, SPI_SETMENUFADE, 0, FALSE, SPIF_SENDWININICHANGE
            	.endif
            	.if bMenuAnim
            	    invoke SystemParametersInfo, SPI_SETMENUANIMATION, 0, FALSE, SPIF_SENDWININICHANGE
                .endif
            
;                PrintDec eax, "INSTALL"
                call UnInstallHookTransparent
                call InstallHookTransparent                    
            .endif   
        
            .if StyleMenu == STYLE_OFFICE_XP || StyleMenu == STYLE_OFFICE_2000 || StyleMenu == STYLE_XNET
                invoke SubMenuToOwnerdraw, hMenu       ;      OWNERDRAW            
            .elseif StyleMenu == STYLE_DEFAULT
                invoke OwnerDrawToNormal, hMenu        ;       OWNERDRAW
            .endif
             
            HIWORD lParam   ;  ?
            .if eax
                invoke IsID_ThemeXP_inc, hWin, hMenu  ; Special purpose for windows XP with themes!!!
            .endif 
            
        .endif

        jmp  d_c

    .elseif uMsg == WM_UNINITMENUPOPUP
       
;       PrintDec wParam, "WM_UNINITMENUPOPUP"       
          mov hMenuForMeasure, 0  
          mov eax, wParam
          .if hMenu == eax && !fAccel

            .if fTransparent
;                PrintDec eax, "UNINSTALL"
                
				.if bMenuFading
				    invoke SystemParametersInfo, SPI_SETMENUFADE, 0, ADDR bMenuFading, SPIF_SENDWININICHANGE
				.endif
				.if bMenuAnim
				    invoke SystemParametersInfo, SPI_SETMENUANIMATION, 0, ADDR bMenuAnim, SPIF_SENDWININICHANGE
                .endif
                
                call UnInstallHookTransparent  
            .endif
          
            mov hMenu, 0            
            HIWORD lParam
            .if eax
                invoke IsID_ThemeXP_dec, hWin, wParam  ; Special purpose for windows XP with themes!!!
            .endif
                                     
          .endif
                
        jmp  d_c
        
    .elseif uMsg == WM_MEASUREITEM

        .if !wParam    ; MENU? (wParam == 0 - only menu)

            invoke IsMenu, hMenuForMeasure
            .if !eax
                return FALSE
            .endif                
                   
            invoke MeasureItem_Menu, lParam            
@@:         return eax

        .else
            jmp  d_c        
        .endif
 
    .elseif uMsg == WM_DRAWITEM

        .if !wParam    ; MENU? (wParam == 0 - only menu)     
            
            invoke IsMenu, hMenu        ;   ,  
            .if !eax 
                return FALSE 
            .endif   
            
            invoke DrawItem_Menu, lParam
            ret     ;  eax == TRUE ? FALSE,        ( ), 
                ;     Win9X.

        .else
            jmp  d_c
        .endif

    .elseif uMsg == WM_ENTERMENULOOP
    
;        PrintDec wParam, "WM_ENTERMENULOOP"
        mov fAccel, FALSE
        jmp  d_c     

    .elseif uMsg == WM_EXITMENULOOP
    
;        PrintDec wParam, "WM_EXITMENULOOP"

        mov fAccel, TRUE
        jmp  d_c

;    .elseif uMsg == WM_WININICHANGE
;
;        PrintDec wParam, "WM_SYSCOLORCHANGE"
;        jmp d_c
;        
;    .elseif uMsg == WM_PARENTNOTIFY
;    
;        HIWORD wParam
;        .if eax == WM_CREATE        
;            .if fTransparent 
;                invoke GetWindowLong, lParam, GWL_EXSTYLE
;                .if !(eax & WS_EX_LAYERED)            
;                    or eax, WS_EX_LAYERED
;                    invoke SetWindowLong, lParam, GWL_EXSTYLE, eax
;                    invoke SetLayeredWindowAttributes, lParam, 0,200, LWA_ALPHA
;                .endif
;            .endif 
;
;        .endif
;    
;        jmp d_c    
        
    .elseif uMsg == WM_DESTROY
;        invoke RemoveProp, hWin, ADDR szProp_OldWndProc      
;        invoke SetWindowLong, hWin, GWL_WNDPROC, OldWndProc
;        call UnInstallHook
        call UnInstallHookTransparent        
        jmp  d_c
    .else

d_c:        
        invoke CallWindowProc,OldWndProc,hWin,uMsg,wParam,lParam
        ret
    .endif           
 
    xor eax,eax
    ret
WndProc_Menu endp

; #########################################################################
;                                                                         ;
;    WM_MeasureItem_Menu.                           ;
;                                                                         ;
; #########################################################################

MeasureItem_Menu proc uses ebx esi edi lParam:LPARAM

    LOCAL mii         :MENUITEMINFOM
    LOCAL mii_first   :MENUITEMINFOM  
    LOCAL mi          :MENUINFO
    LOCAL ddbinfo     :BITMAP
    LOCAL szBuff[max_len_menu_item]:BYTE
    LOCAL hDC         :HDC
    LOCAL StrSize     :SIZEL
    LOCAL StrSizeClose:SIZEL
    LOCAL RctText     :RECT
    LOCAl TextItemLen :DWORD
    LOCAL ncinfo      :NONCLIENTMETRICS
    LOCAL hfontMenu   :HFONT
    LOCAL iconinfo   :ICONINFO
    LOCAL bmp        :BITMAP
    LOCAL MaxWidth    :DWORD
    LOCAl MaxWidthBorder:DWORD      ;    ()
    LOCAL hOldFont   :DWORD
    LOCAL l_word     :WORD
    LOCAL h_word     :WORD

    mov ebx, lParam
    assume ebx: ptr MEASUREITEMSTRUCT
     
    .if [ebx].CtlType == ODT_MENU    
    
        invoke memfill, ADDR mii, sizeof(MENUITEMINFO), 0        
        mov mii.cbSize, SIZEOF mii
        mov mii.fMask, MIIM_TYPE or MIIM_DATA or MIIM_STATE
        invoke GetMenuItemInfo, hMenuForMeasure, [ebx].itemID, FALSE, ADDR mii

        ;   1-   ,    
        ;   ,    
        mov mii_first.cbSize, SIZEOF mii_first
        mov mii_first.fMask, MIIM_ID
        invoke GetMenuItemInfo, hMenuForMeasure, 0, TRUE, ADDR mii_first
        mov eax, [ebx].itemID
        .if mii_first.wID == eax
            mov mi.cbSize, sizeof (MENUINFO)
            mov mi.fMask, MIM_MENUDATA
            mov mi.dwMenuData, 0
            invoke SetMenuInfo, hMenuForMeasure, ADDR mi
        .endif
        
        mov eax, mii.fType
        and eax, MFT_SEPARATOR or MFT_STRING or MFT_BITMAP

        .if eax == MFT_SEPARATOR
        
            .if mii.dwItemData
             
                    mov [ebx].itemHeight, 5 ;  
            
                    push 0
                    push 0
                    push hMenuForMeasure
                    call mii.dwItemData
                    .if eax
                        mov [ebx].itemWidth, eax
                    .else
                        m2m [ebx].itemWidth, LeftBmpWidth
                    .endif
                     
            .else
                mov [ebx].itemHeight, 6
                mov [ebx].itemWidth, 8
            .endif
            
        .elseif eax == MFT_STRING || [ebx].itemID
            
            mov mi.cbSize, sizeof (MENUINFO)
            mov mi.fMask, MIM_MENUDATA
            invoke GetMenuInfo, hMenuForMeasure, ADDR mi

            invoke GetMenuString, hMenuForMeasure, [ebx].itemID, ADDR szBuff, max_len_menu_item, MF_BYCOMMAND
            mov TextItemLen, eax

            .if eax

                mov hDC, $invoke (GetDC, NULL)
                invoke memfill, ADDR ncinfo, sizeof(NONCLIENTMETRICS), 0
                mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)             ;   
                invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                                        sizeof(NONCLIENTMETRICS),\
                                        ADDR ncinfo, 0              ;  ,    
                
                .if mii.fState & MFS_DEFAULT
                    mov ncinfo.lfMenuFont.lfWeight, FW_BOLD
                .endif               
                invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont         ;  
                mov hfontMenu, eax
                mov hOldFont, $invoke (SelectObject, hDC, hfontMenu)                
                
                mov MaxWidth, 0
                cld                         ;    
                lea edi, szBuff             ;  
                mov al, 09h                 ;  
                mov ecx, TextItemLen        ;  
                repne scasb                 ;   '\t'  
                jne no_t
                
                ;      /t
                invoke GetTextExtentPoint32, hDC, edi, ecx, ADDR StrSize
                invoke GetMaxWidthMenuItem, hDC, hMenuForMeasure
                mov MaxWidth, eax              
                call IsShellType
                .if eax >= WIN_2000
                    mov eax, MaxWidth
                    add StrSize.x, eax
                .else
                    mov eax, MaxWidth
                    mov StrSize.x, eax      ;  Win9x   /t,    
                .endif
                
                jmp @f
                
no_t:           invoke GetTextExtentPoint32, hDC, ADDR szBuff, TextItemLen, ADDR StrSize
@@:             
                ;     ,  WIN_2000,XP 
                ; WM_MEASUREITEM   .
                ; Special case for system menu
                call IsShellType                     
                .if [ebx].itemID >= SC_SIZE && [ebx].itemID <= SC_HOTKEY && eax >= WIN_2000 && !MaxWidth
                    mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)             ;   
                    invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                                        sizeof(NONCLIENTMETRICS),\
                                        ADDR ncinfo, 0              ;  ,    
                    mov ncinfo.lfMenuFont.lfWeight, FW_BOLD
            
                    invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont         ;  
                    invoke SelectObject, hDC, eax
                    push eax

                    invoke GetTextExtentPoint32, hDC, ADDR ShorcutClose, 6, ADDR StrSizeClose
                    invoke GetMaxWidthMenuItem, hDC, hMenuForMeasure
                    mov MaxWidth, eax                
                    add eax, StrSizeClose.x                    
                    mov StrSize.x, eax
                    
                    push hDC       ;  
                    call SelectObject
                    invoke DeleteObject, eax                    
                .endif
                  
                invoke SelectObject, hDC, hOldFont       ;  
                invoke DeleteObject, hfontMenu
                invoke ReleaseDC, NULL, hDC
                
                .if !MaxWidth                
                    m2m MaxWidth, StrSize.x
                .endif
                
            .endif
                    
            invoke memfill, ADDR bmp, sizeof(BITMAP), 0
            .if mii.dwItemData               
                ;    
                invoke GetIconInfo, mii.dwItemData,ADDR iconinfo
                .if eax
                    invoke GetObject, iconinfo.hbmColor, sizeof(BITMAP), ADDR bmp
                    invoke DeleteObject, iconinfo.hbmMask
                    invoke DeleteObject, iconinfo.hbmColor 
                .endif                   
            .endif
             
            mov eax, StrSize.y
            add eax, 7
            mov ecx, bmp.bmHeight
            add ecx, 4              ; 2  ,  1  .
            
            .if ecx > eax
                mov eax, ecx            
            .endif                                                            
            mov [ebx].itemHeight, eax       ;  
            
            mov edx, eax
            HIWORD mi.dwMenuData
            mov ecx, eax
            LOWORD mi.dwMenuData
            .if (eax < edx) || (ecx < MaxWidth)
             
                ;       
                .if eax < edx
                    mov l_word, dx
                .else
                    mov l_word, ax
                .endif
                
                ;   
                .if ecx < MaxWidth
                    m2m h_word, word ptr MaxWidth
                .else
                    mov h_word, cx
                .endif               
                MAKEDWORD l_word, h_word           
                mov mi.dwMenuData, eax
                invoke SetMenuInfo, hMenuForMeasure, ADDR mi
            .endif

            add [ebx].itemHeight, 2         ; ,                              
            ;   ,    
            LOWORD mi.dwMenuData
            add eax, 4+2                    ;  
            add StrSize.x, eax              ;                
            
            m2m [ebx].itemWidth, StrSize.x  ;              
            
        .elseif eax == MFT_BITMAP
        
            ; retrieve DDB information
            invoke GetObject, mii.dwTypeData, sizeof(BITMAP), ADDR ddbinfo                
            m2m [ebx].itemWidth, ddbinfo.bmWidth
            m2m [ebx].itemHeight, ddbinfo.bmHeight        

        .else
        
            assume ebx: nothing
            return FALSE
        
        .endif
        
    .else
    
        assume ebx: nothing
        return FALSE    
                            
    .endif   

    assume ebx: nothing
    return TRUE
MeasureItem_Menu endp

GetMaxWidthMenuItem proc uses edi hDC:HDC, hPopupMenu:HMENU

    LOCAL nPos        :DWORD
    LOCAL LastItemID  :UINT
    LOCAL mii         :MENUITEMINFOM
    LOCAl TextItemLen :DWORD
    LOCAL szBuff[max_len_menu_item]:BYTE
    LOCAL MaxWidth    :DWORD
    LOCAL RctText     :RECT
    LOCAL ncinfo      :NONCLIENTMETRICS
    LOCAL hfontMenu   :HFONT
    LOCAL lfMenuFont  :LOGFONT
    LOCAL StrSize     :SIZEL
    LOCAL nMaxItemCount:DWORD

    mov MaxWidth, 0
    mov mii.cbSize, sizeof (MENUITEMINFOM)
    mov mii.fMask, MIIM_STATE
    mov nMaxItemCount, $invoke (GetMenuItemCount, hPopupMenu)
    mov nPos, 0

s_t:

    invoke GetMenuString, hPopupMenu, nPos, ADDR szBuff, max_len_menu_item, MF_BYPOSITION
    mov TextItemLen, eax
     
    .if TextItemLen

            cld
            lea edi, szBuff             ;  
            mov al, 09h                 ;  
            mov ecx, TextItemLen        ;  
            repne scasb                 ;   '\t'  
            jne @f 

            sub TextItemLen, ecx
            
;            dec  TextItemLen
;            mov TextItemLen, 0
            
@@:        
            invoke memfill, ADDR ncinfo, sizeof(NONCLIENTMETRICS), 0
            mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)             ;   
            invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                                    sizeof(NONCLIENTMETRICS),\
                                    ADDR ncinfo, 0              ;  ,    
            
            invoke GetMenuItemInfo, hPopupMenu, nPos, TRUE, ADDR mii
            .if mii.fState & MFS_DEFAULT
                mov ncinfo.lfMenuFont.lfWeight, FW_BOLD                        
            .endif
            
            invoke CreateFontIndirect, ADDR ncinfo.lfMenuFont         ;  
            invoke SelectObject, hDC, eax
            push eax
            ;invoke DrawText, hDC, ADDR szBuff, TextItemLen, ADDR RctText, DT_CALCRECT
            invoke GetTextExtentPoint32, hDC, ADDR szBuff, TextItemLen, ADDR StrSize
            push hDC
            call SelectObject       ;  
            invoke DeleteObject, eax         

;            mov eax, RctText.right
;            sub eax, RctText.left
            mov eax, StrSize.x
            .if eax > MaxWidth
                mov MaxWidth, eax
            .endif
    .endif     

    inc nPos
        
    mov eax, nPos
    cmp eax, nMaxItemCount    
    jb  s_t
    
    mov eax, MaxWidth
    ret
GetMaxWidthMenuItem endp

; #########################################################################
;                                                                         ;
;         (  );                           ;
;                                                                         ;
; #########################################################################

;SetSizeBorder proc hDC:HDC, lpTextItem:DWORD, TextItemLen:DWORD, hIcon:DWORD, bDefault:DWORD 
;
;    LOCAL StrSize     :SIZEL
;    LOCAL RctText     :RECT
;    LOCAL ncinfo      :NONCLIENTMETRICS
;    LOCAL iconinfo   :ICONINFO
;    LOCAL bmp        :BITMAP
;    
;    mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)             ;   
;    invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
;                            sizeof(NONCLIENTMETRICS),\
;                            ADDR ncinfo, 0              ;  ,    
;    .if bDefault
;        mov ncinfo.lfMenuFont.lfWeight, FW_BOLD
;    .endif
;    invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont         ;  
;    
;    invoke SelectObject, hDC, eax
;    push eax    
;    invoke GetTextExtentPoint32, hDC, lpTextItem, TextItemLen, ADDR StrSize
;    
;    push hDC
;    call SelectObject               ;  
;    invoke DeleteObject, eax                   
;    
;    invoke memfill, ADDR bmp, sizeof(BITMAP), 0
;    .if hIcon                  
;        ;    
;        invoke GetIconInfo, hIcon,ADDR iconinfo
;        invoke GetObject, iconinfo.hbmColor, sizeof(BITMAP), ADDR bmp
;        invoke DeleteObject, iconinfo.hbmMask
;        invoke DeleteObject, iconinfo.hbmColor                   
;    .endif    
;                    
;    mov eax, StrSize.y
;    add eax, 7
;    mov ecx, bmp.bmHeight
;    add ecx, 4              ; 2  ,  1  .
;    
;    .if ecx > eax
;        sub ecx, eax
;        add eax, ecx 
;    .endif                                                            
;    mov HeightBorder, eax           ;  
;    mov WidthBorder, eax            ;  
;
;	ret
;SetSizeBorder endp

; #########################################################################
;                                                                         ;
;    WM_DRAWITEM.                              ;
;                                                                         ;
; #########################################################################

DrawItem_Menu proc uses ebx lParam:LPARAM

mov ebx, lParam
assume ebx: ptr DRAWITEMSTRUCT

    invoke IsMenu, hMenu
    .if !eax
        jmp e_t
    .endif

  .if [ebx].CtlType == ODT_MENU

    invoke SaveDC, [ebx].hdc    
                
    invoke SetBkMode, [ebx].hdc, TRANSPARENT
    
    .if StyleMenu == STYLE_OFFICE_XP              ;   OFFICE XP
        call DrawItem_MenuXP ;, lParam           ;  
    .elseif StyleMenu == STYLE_OFFICE_2000        ;   OFFICE 2000    
        call DrawItem_Menu2000 ;, lParam         ;  
    .elseif StyleMenu == STYLE_XNET               ;   OFFICE 2000
        call DrawItem_MenuXNET
    .elseif StyleMenu == STYLE_DEFAULT            ; Default -   " "     
        call DrawItem_MenuDefault
    .else
        jmp e_t      
    .endif
    
    invoke RestoreDC, [ebx].hdc, -1
    mov eax, TRUE
    
  .else
    
e_t:  
    mov eax, FALSE
  
  .endif

    assume ebx:nothing
    ret
DrawItem_Menu endp

; #########################################################################
;                                                                         ;
;      (    );
;                                                                         ;
; #########################################################################

DrawBmp proc uses ebx hDC:HDC, lpRect:DWORD, hBmp:HBITMAP, uFlags:BYTE, WidthBorder

    LOCAL RctBmp                :RECT
    LOCAL GlyphArray[2]         :BYTE
    LOCAL hGlyphFont            :HFONT
    LOCAL OldFont               :HFONT
    LOCAL OldClr                :COLORREF
    LOCAL ncinfo                :NONCLIENTMETRICS
   
        mov ebx, lpRect

        .if hBmp == HBMMENU_POPUP_MINIMIZE  
        
            mov GlyphArray, 30h          
        
        .elseif hBmp == HBMMENU_POPUP_MAXIMIZE
        

            mov GlyphArray, 31h
        
        .elseif hBmp == HBMMENU_POPUP_CLOSE
        
            mov GlyphArray, 72h
            
        .elseif hBmp == HBMMENU_POPUP_RESTORE
            
            mov GlyphArray, 32h
            
        .else        
        
            jmp exit_
        .endif

   ;     CheckItema.   
   
        mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)           ;   
        invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                                  sizeof(NONCLIENTMETRICS),\
                                  addr ncinfo, 0                                      ;  ,    
        
        
;        .if ncinfo.lfMenuFont.lfHeight > -15
;            mov ncinfo.lfMenuFont.lfHeight, -15
;        .endif
        
        ;   mov ncinfo.lfMenuFont.lfWidth, 14
        
        mov ncinfo.lfMenuFont.lfCharSet, DEFAULT_CHARSET
        
        invoke memfill, ADDR ncinfo.lfMenuFont.lfFaceName, LF_FACESIZE, 0
        invoke szCopy, ADDR szGlyphFont, ADDR ncinfo.lfMenuFont.lfFaceName                             
        invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont
        mov hGlyphFont, eax

        invoke GetTextColor,hDC
        mov OldClr, eax

        invoke SetBkMode,hDC,TRANSPARENT
        invoke SelectObject, hDC, hGlyphFont
        mov OldFont, eax
        
        xor eax, eax                    ;  
        mov al, uFlags 
        and al, SELECT or UNSELECT
        
        .if al == GRAY

            invoke DarkenColor, 8, $invoke ( GetSysColor, COLOR_GRAYTEXT )   ; 
            invoke SetTextColor, hDC, eax
            mov OldClr, eax
            jmp @f
        
        .elseif al == UNSELECT
@@:
            mov eax, [ebx].RECT.left        ;   
            mov RctBmp.left, eax
            mov eax, [ebx].RECT.top
            mov RctBmp.top, eax
            mov eax, [ebx].RECT.left
            add eax, WidthBorder       
            mov RctBmp.right, eax
            mov eax, [ebx].RECT.bottom
            mov RctBmp.bottom, eax        
            
        .elseif al == SELECT

            invoke DarkenColor, 8, $invoke ( GetSysColor, COLOR_GRAYTEXT )   ; 
            invoke SetTextColor, hDC, eax
            mov OldClr, eax
             
            mov eax, [ebx].RECT.left        ;   
            inc eax
            mov RctBmp.left, eax
            mov eax, [ebx].RECT.top
            inc eax
            mov RctBmp.top, eax            
            mov eax, [ebx].RECT.left
            add eax, WidthBorder
            inc eax
            mov RctBmp.right, eax            
            mov eax, [ebx].RECT.bottom
            inc eax
            mov RctBmp.bottom, eax                   
           
            invoke DrawText, hDC, ADDR GlyphArray, 1, ADDR RctBmp, DT_CENTER or DT_VCENTER or DT_SINGLELINE
            
            mov eax, [ebx].RECT.left        ;   
            dec eax
            mov RctBmp.left, eax
            mov eax, [ebx].RECT.top
            dec eax
            mov RctBmp.top, eax
            mov eax, [ebx].RECT.left            
            add eax, WidthBorder
            dec eax       
            mov RctBmp.right, eax
            mov eax, [ebx].RECT.bottom
            dec eax
            mov RctBmp.bottom, eax
            invoke SetTextColor,hDC, OldClr
                                
        .endif
                      
        invoke DrawText, hDC, ADDR GlyphArray, 1, ADDR RctBmp, DT_CENTER or DT_VCENTER or DT_SINGLELINE
        invoke SelectObject,hDC, OldFont           ;   
        invoke DeleteObject, hGlyphFont
        invoke SetTextColor,hDC, OldClr       
        
exit_:

        
    ret
DrawBmp endp

; #########################################################################
;                                                                         ;
;     ,  /t, /a                        ;
;                                                                         ;
; #########################################################################

DrawMenuString proc uses edi hMemDC:HDC, h_Menu:HMENU, lpString:LPSTR, TextItemLen:DWORD, lpRect:DWORD, MaxWidth:DWORD

        LOCAL Rct         :RECT

        cld
        mov edi, lpString           ;  
        mov al, 09h                 ;  
        mov ecx, TextItemLen        ;  
        repne scasb                 ;   '\t'  
        jne @f        
        
        push ecx
        invoke CopyRect, ADDR Rct, lpRect    
        mov eax, MaxWidth
        add Rct.left, eax
        pop ecx
        push ecx
        invoke DrawText, hMemDC, edi, ecx, ADDR Rct, DT_VCENTER+DT_SINGLELINE+DT_NOCLIP+DT_LEFT
        pop ecx
        sub TextItemLen, ecx
        dec TextItemLen
        
        jmp draw_left       
        
@@:     cld                         ;    
        mov edi, lpString           ;  
        mov al, 08h                 ;  
        mov ecx, TextItemLen        ;  
        repne scasb                 ;   '\a'  
        jne draw_left
        
        push ecx
        invoke CopyRect, ADDR Rct, lpRect
        m2m Rct.right, Rct.left
        mov eax, MaxWidth
        add Rct.right, eax
        pop ecx
        push ecx
        invoke DrawText, hMemDC, edi, ecx, ADDR Rct, DT_VCENTER+DT_SINGLELINE+DT_RIGHT+DT_NOCLIP
        pop ecx
        sub TextItemLen, ecx
        dec TextItemLen

draw_left:                 
        invoke DrawText, hMemDC, lpString, TextItemLen, lpRect, DT_VCENTER+DT_SINGLELINE+DT_LEFT+DT_NOCLIP
 	
 	ret
DrawMenuString endp

; =========================================================================
;                  
;
; #########################################################################
;                                                                         ;
;       ,       ;  
;   OWNERDRAW     .                      ;
;                                                                         ;
; #########################################################################

PUBLIC SetStyleMenu

SetStyleMenu proc dwStyle:DWORD

    push StyleMenu
    m2m StyleMenu, dwStyle   
    pop eax
    
    ret
SetStyleMenu endp

PUBLIC RedrawWindowMenu

RedrawWindowMenu proc hWin:HWND

    invoke IsWindow, hWin
    .if !eax
        return FALSE
    .endif

    invoke SetNewWndProc, hWin, ADDR szProp_OldWndProcMenu, ADDR WndProc_Menu
   
    invoke GetSystemMenu, hWin, FALSE
   
    return TRUE
RedrawWindowMenu endp

; #########################################################################
;                                                                         ;
;      .                          ;  
;                                                                         ;
; #########################################################################

PUBLIC SetTransparentMenu

SetTransparentMenu proc bAlpha:BYTE    

    push dword ptr fTransparent
    mov al, bAlpha
    mov fTransparent, al
    pop eax 
   
    ret
SetTransparentMenu endp

; #########################################################################
;                                                                         ;
;      .                          ;  
;                                                                         ;
; #########################################################################

PUBLIC GetStyleMenu

GetStyleMenu proc

    mov eax, StyleMenu 
   
    ret
GetStyleMenu endp

; #########################################################################
;                                                                         ;
;      .                     ;
;                                                                         ;
; #########################################################################

PUBLIC SetMenuItemIcon

SetMenuItemIcon proc h_Menu:HMENU, ItemID:DWORD, hIcon:HICON

   LOCAL mii      :MENUITEMINFOM
   
    mov mii.cbSize, sizeof (MENUITEMINFOM)
    mov mii.fMask, MIIM_DATA   
    m2m mii.dwItemData, hIcon
    invoke SetMenuItemInfo, h_Menu, ItemID, FALSE, ADDR mii

    ret
SetMenuItemIcon endp

; #########################################################################
;                                                                         ;
;       .                     ;
;                                                                         ;
; #########################################################################

PUBLIC SetMenuIcon

SetMenuIcon proc uses ebx h_Menu:HMENU, hImageList:HIMAGELIST, uNumButtons:DWORD, lpButtons:DWORD 

mov ebx, lpButtons

    .while uNumButtons
       
        invoke ImageList_GetIcon, hImageList, [ebx].MNUBUTTON.nIcon, ILD_NORMAL
        invoke SetMenuItemIcon, h_Menu, [ebx].MNUBUTTON.idItem, eax
        add ebx, sizeof (MNUBUTTON)
        dec uNumButtons

    .endw

    ret
SetMenuIcon endp

; #########################################################################
;                                                                         ;
;      .                     ;
;                                                                         ;
; #########################################################################

PUBLIC SetDisableSelect

SetDisableSelect proc uses edx bShow:BYTE

    xor eax, eax
    mov al, fSelection
    mov dl, bShow
    mov fSelection, dl

    ret
SetDisableSelect endp

; #########################################################################
;                                                                         ;
;                    ;
;                                                                         ;
; #########################################################################

PUBLIC AddLeftBorder

AddLeftBorder proc h_Menu:HMENU, lpDrawBorderProc:DWORD, Break:BOOLEAN

    LOCAL mii   :MENUITEMINFOM
    
    invoke IsMenu, h_Menu
    .if !eax
        return 0
    .endif
    
    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_FTYPE or MIIM_ID or MIIM_DATA    
    mov mii.fType, MFT_SEPARATOR or MFT_OWNERDRAW
    call ansi_rand
    mov mii.wID, eax
    m2m mii.dwItemData, lpDrawBorderProc
    invoke InsertMenuItem, h_Menu, 0, TRUE, ADDR mii 

;    invoke memfill, ADDR mii, sizeof(MENUITEMINFOM), 0

    mov mii.fMask, MIIM_FTYPE
    invoke GetMenuItemInfo, h_Menu, 1, TRUE, ADDR mii 

    .if Break
        or mii.fType, MFT_MENUBARBREAK
    .else
        or mii.fType, MFT_MENUBREAK
    .endif
    invoke SetMenuItemInfo, h_Menu, 1, TRUE, ADDR mii

    ret
AddLeftBorder endp

; #########################################################################
;                                                                         ;
;                     ;
;                                                                         ;
; #########################################################################

PUBLIC RemoveLeftBorder

RemoveLeftBorder proc h_Menu:HMENU

    LOCAL mii   :MENUITEMINFOM
     
    invoke IsMenu, h_Menu
    .if !eax
        return 0
    .endif 
        
    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_FTYPE or MIIM_DATA 
    invoke GetMenuItemInfo, h_Menu, 0, TRUE, ADDR mii 
    
    .if mii.fType & MFT_SEPARATOR && mii.dwItemData   
        invoke RemoveMenu, h_Menu, 0, MF_BYPOSITION
        
        mov mii.fMask, MIIM_FTYPE
        invoke GetMenuItemInfo, h_Menu, 0, TRUE, ADDR mii
        .if mii.fType & MFT_MENUBARBREAK
            xor mii.fType, MFT_MENUBARBREAK
        .else
            xor mii.fType, MFT_MENUBREAK
        .endif     
        
        invoke SetMenuItemInfo, h_Menu, 0, TRUE, ADDR mii
    .else
        return 0
    .endif
    
    ret
RemoveLeftBorder endp